PROGS_TMP	= $(MAINS:%.cpp=%)
PROGS		= $(PROGS_TMP:%.c=%)
PROGS_EXE	= # Not define here but in bin_template

LOCAL_DEP_PATH = .dep
LOCAL_OBJ_PATH = .obj
DEPFILES_TMP=$(MAINS:%.cpp=$(LOCAL_DEP_PATH)/%.P)
DEPFILES    =$(DEPFILES_TMP:%.c=$(LOCAL_DEP_PATH)/%.P)
DEPFILES    +=$(foreach TARGET,$(PROGS),$($(TARGET)_OBJ:%.o=$(LOCAL_DEP_PATH)/%.P))

ifeq ($(SUFFIX), _insure)
DEP_FILE	= $*.d
else
DEP_FILE	= $(*F)$(SUFFIX).d
endif


define bin_template
$(1)_BIN_PATH ?= $$(PROJECT_BIN_PATH)
PROGS_EXE += $$($(1)_BIN_PATH)/$(1)$$(BIN_EXTENSION)
$$($(1)_BIN_PATH)/$(1)$$(BIN_EXTENSION): $$($(1)_OBJ_FILES) $(1:%=$(LOCAL_OBJ_PATH)/%.o)
	@echo "*"
	@echo  "* Linking $$(@F)  "
	@echo "*"
	$$(CXXALL) -MD $$^ -o $$@ $$($(1)_EXT_OBJ) $$(LDFLAGS) $$(LIBS) $$($(1)_LDFLAGS) 
endef

$(LOCAL_OBJ_PATH)/%.o: %.cpp
	@echo "*"
	@echo  "* Compiling $@ "
	@echo "*"
	@if [ ! -d $(LOCAL_OBJ_PATH) ] ; then mkdir $(LOCAL_OBJ_PATH) ; fi ;
	@if [ ! -d $(LOCAL_DEP_PATH) ] ; then mkdir $(LOCAL_DEP_PATH) ; fi ;
	$(CXXALL) -MD -o $@ -c $<
	@cp $(@:%.o=%.d) $(LOCAL_DEP_PATH)/$*.P; \
	sed -e 's/#.*//' -e 's/^[^:]*: *//' -e 's/ *\\$$//' \
	    -e '/^$$/ d' -e 's/$$/ :/' < $(@:%.o=%.d)\
	    >> $(LOCAL_DEP_PATH)/$*.P; \
	rm -f $(@:%.o=%.d)


$(foreach TARGET,$(PROGS),$(eval $(call bin_template,$(TARGET))))

