# --- RULES ---------------------------------------------------------------
LINK_FLAGS +=  
COMMON_TARGET_H= plugin.h $(CONTROLLER)/$(CORBA_DIR)/common.h
CXX_FLAGS += -I$(SOURCE_DIR)/$(ORBIX_CPP_DIR)

define object_template
$(1)_OBJS := $(1:%=$(IOSRVBIN)/%.$(OSFX))
$(1)_SRC := $(1:%=$(2)/%.cpp)
USER_OBJS    += $$($(1)_OBJS)
$$($(1)_OBJS): $$($(1)_SRC) $(3)
	@echo Compiling $(1) 
	$(CXX) $(CFLAGS) -I../../robot/$(ROBOT) $$< -o $$@ -MD 
	@cp $$*.d $(PROJECT_DEP_PATH)/$$(notdir $$*.P); \
	sed -e 's/#.*//' -e 's/^[^:]*: *//' -e 's/ *\\$$$$//' \
	    -e '/^$$$$/ d' -e 's/$$$$/ :/' < $$*.d\
	    >> $(PROJECT_DEP_PATH)/$$(notdir $$*.P); \
	rm -f $$*.d
DEPFILES +=  $(PROJECT_DEP_PATH)/$$(notdir $$($(1)_OBJS:%.o=%.P))

TEST += $(1)
endef

define plugin_template
USER_PLUGINS += $(IOSRVBIN)/$(1).$(DLLSFX)
USER_SCRIPTS += $($(1)_SCRIPTS:%=$(IOSRVBIN)/script/%.py)
.PHONY : $($(1)_EXT_OBJS) 
$(IOSRVBIN)/$(1).$(DLLSFX): $($(1)_SRC:%=$(IOSRVBIN)/%.$(OSFX)) \
	$($(1)_CORBA:%=$(IOSRVBIN)/%.$(OSFX)) \
	$($(1)_EXT_OBJS) 
$(foreach OBJECTS,$($(1)_SRC),$(eval $(call object_template,$(OBJECTS),$(SOURCE_DIR))))
$(foreach OBJECTS,$($(1)_CORBA),$(eval $(call object_template,$(OBJECTS),$(SOURCE_DIR)/$(ORBIX_CPP_DIR))))
endef


$(foreach TARGET,$(PLUGINS),$(eval $(call plugin_template,$(TARGET))))
# ------------------------------------------------------------
user_all: user_targets installscript

user_targets:make_stubskel $(USER_PLUGINS)

$(USER_PLUGINS):
	$(LINK) $(SOFLAGS) $(OUTOPT)$@ $^ $(LDFLAGS) $(LIBS)
make_stubskel:
	cd $(CONTROLLER)/$(CORBA_DIR);make

user_install:
	cp -f $(SOURCE_DIR)/script/* $(IOSRVBIN)/script
user_clean:
	rm -f $(USER_PLUGINS) $(USER_OBJS)
	rm -f common.h 
	rm -f $(PROJECT_HOME)/plugin/*~

$(IOSRVBIN)/script/%.py: $(SOURCE_DIR)/%.py
	ln -snf $< $@

installscript:$(USER_SCRIPTS) 

-include $(DEPFILES)

test:
	@echo $(DEPFILES)	

