/*! 
  \defgroup examplesprog Controlling the SOT with the shell.
  \ingroup codesourceexamples
  
  \dontinclude test_shell.cpp
  
  The first headers allow to access the core objects of the SOT.
  
  \skipline sotFactory
  \until sotFeatureAbstract
  
  The following headers allow access to the interpretor and the 
  plugin handling.

  \skipline sotPluginLoader
  \until sotInterpretor

  The last header is only for debugging purposes.
  \skipline sotDebug

  Some macros from sotDebug are then available to trace
  the state of the program.
  \skipline using
  \until sotDEBUGIN

  It is possible to use the object sotPluginLoader to specify
  the directory where the plugins are located.
  They can be loaded by specifying a list of dynamically loadable
  libraries, and ask them to be loaded.
  This can also be perfom directly inside the script.
  \skipline try
  \until loadPlugins
  
  This plugin loader is then related to an object sotInterpretor
  which act as an interface to the plugins. In this case we use
  the singleton provided inside the library sotShell.
  \skipline sotShell
  
  In this program each file specify in arguments of the program is
  loaded.
  \skipline for(
  \until }
  
  The input stream and output stream of the sotIntepretor object
  can be specified. Here it is the standard input and the standard output.
  
  \skipline sotShell
  \until }
  
  \defgroup examplesscript Command to test the plugins with test_shell
  \ingroup codesourceexamples 
  
  Objects in the libraries are handled by an object called the pool.
  To see all the object loaded inside the library tries:</br>
  pool.list</br>
  
  To have a comprehensive list of the commands for pool tries:</br>
  pool.help</br>
  
  \ingroup codesourceexamples CORBA client to access the plugin sotServerCommand
  
  \dontinclude test_corba_shell.cpp    
*/
