function [nerr paramsqp sRh sc mg gamma K Sk_sc ] = calibLin( fs,rqs,paramsDefaultOrder,paramsDefault,paramsOptOrder,paramsOpt,opts );
argc=nargin;
if( argc==2 ) opts=''; end
if( argc==3 ) 
     opts=paramsDefaultOrder;  paramsDefaultOrder={}; paramsDefault=[];
     paramsOptOrder={}; paramsOpt=[];
end
if( argc==4 ) 
     opts=''; paramsOptOrder={}; paramsOpt=[];
end
if( argc==5 ) 
     opts=paramsOptOrder; paramsOptOrder={}; paramsOpt=[];
end
if( argc==6 ) 
     opts='';
end

uteta_sRh=[0 0 -pi/2]; 
sc=[0 0 -0.05];  
mg=[ 0;0;-8]; 
gamma_f=mg;
gamma_tau=0;
gains=zeros(6);
fact_f=1; fact_tau=1; fact_gain=2.5;

params=paramsDefault; 
paramsOrder=paramsDefaultOrder;
for twopass=1:2
curs=1;
for i=1:length(paramsOrder)
     if strcmp(paramsOrder(i),'sRh') 
       uteta_sRh=params(curs:curs+2)'; curs=curs+3;
     end
     if strcmp(paramsOrder(i),'sc') 
       sc=params(curs:curs+2)'; curs=curs+3;
     end
     if strcmp(paramsOrder(i),'mg') 
       mg=[0;0;params(curs)]; curs=curs+1;
     end
     if strcmp(paramsOrder(i),'mg3') 
       mg=params(curs:curs+2)'; curs=curs+3;
     end
     if strcmp(paramsOrder(i),'gamma6') 
       gamma_f=params(curs:curs+2)'; curs=curs+3;
       gamma_tau=params(curs:curs+2)'; curs=curs+3;
     end
     if strcmp(paramsOrder(i),'gammaf') 
       gamma_f=params(curs:curs+2)'; curs=curs+3;
     end
     if strcmp(paramsOrder(i),'gammatau') 
       gamma_tau=params(curs:curs+2)'; curs=curs+3;
     end
     if strcmp(paramsOrder(i),'gain36') 
       gains=gains+reshape(params(curs:curs+35),6,6);
       curs=curs+36;
     end
     if strcmp(paramsOrder(i),'gain18') 
       Kf=reshape(params(curs:curs+8),3,3); curs=curs+9;
       Ktau=reshape(params(curs:curs+8),3,3); curs=curs+9;
       gains=gains+[Kf zeros(3); zeros(3) Ktau];
     end
     if strcmp(paramsOrder(i),'gain6') 
       gains=gains+diag(params(curs:curs+5)); curs=curs+6;
     end
     if strcmp(paramsOrder(i),'gainf9') 
       Ktau=reshape(params(curs:curs+8),3,3); curs=curs+9;
       gains=gains+[Kf zeros(3); zeros(3) zeros(3)];
     end
     if strcmp(paramsOrder(i),'gaintau9') 
       Ktau=reshape(params(curs:curs+8),3,3); curs=curs+9;
       gains=gains+[zeros(3) zeros(3); zeros(3) Ktau];
     end
     if strcmp(paramsOrder(i),'gaintau3') 
       Ktau=diag(params(curs:curs+2)); curs=curs+3;
       gains=gains+[zeros(3) zeros(3); zeros(3) Ktau];
     end
     if strcmp(paramsOrder(i),'gainf3') 
       Kf=diag(params(curs:curs+2)); curs=curs+3;
       gains=gains+[Kf zeros(3); zeros(3) zeros(3)];
     end
     if strcmp(paramsOrder(i),'normf') 
       fact_f=params(curs); curs=curs+1;
     end
     if strcmp(paramsOrder(i),'normtau') 
       fact_tau=params(curs); curs=curs+1;
     end
     if strcmp(paramsOrder(i),'normgain') 
       fact_gain=params(curs); curs=curs+1;
     end
end
params=paramsOpt;
paramsOrder=paramsOptOrder;
end

sRh=tomatrix(uteta_sRh);
K=gains+eye(6);
Sk_sc=[ 0 -sc(3) sc(2); sc(3) 0 -sc(1); -sc(2) sc(1) 0];
if(gamma_tau==0) gamma_tau=-Sk_sc*mg; end;
gamma=[gamma_f;gamma_tau];
sVh=[sRh zeros(3);zeros(3) sRh];



% mgs=[];
% for i=1:length(rqred) 
%     hRw=reshape(rqred(i,[1:3 5:7 9:11]),3,3);
%     hVw=[hRw ;zeros(3)];
%     mgs=[mgs hVw*mg];
% end
% 
% 
% hVs=[sRh' zeros(3);zeros(3) sRh'];
% Kh=hVs*K;
% 
% gammaH=Kh*gamma; 
% gammaH=hVs*K*inv(hVs)*gamma; 
% 
% fnull=([Kh gammaH]*[fred';ones(1,nf)]-[eye(3) zeros(3);Sk_sc eye(3)]*mgs);
% fnull=[ Kh gammaH [  zeros(3) ; Sk_sc]]*[fred';ones(1,nf);-mgs(1:3,:)]-mgs;
% 
% Lf=[fred';ones(1,nf);-mgs(1:3,:)];
% X=[ Kh gammaH [  zeros(3) ; Sk_sc]];
% fnull=X*Lf-mgs;
% plot(fnull');
% 
% X=mgs*pinv(Lf);
% 
% 
% 
% 
% % ----------------------------------
% 

rqred=rqs;
fred=fs;

mgs=[];
for i=1:length(rqred) 
    hRw=reshape(rqred(i,[1:3 5:7 9:11]),3,3);
    hVw=[hRw ;zeros(3)];
    mgs=[mgs hRw*mg];
end

% --- L is the data matrix
L=[ fred mgs' ones(length(fred),1)];
% --- Ck is the gain selection matrix
Ck=[eye(6) zeros(6,4); zeros(4,6) zeros(4)];

sVh=[sRh zeros(3); zeros(3) sRh ];
beta=inv(sVh)*K*sVh*gamma;
X=[eye(3) ;Sk_sc];
Yt=[ inv(sVh)*K -X beta ];
Y=Yt';
y=reshape(Y,60,1);

% Ld=[]; y=[];  Cdk=[];
% [n k]=size(L); 
% [nc kc]=size(Ck); 
% for i=1:6 
%   y=[y;Y(:,i)]; 
%   [nd kd]=size(Ld); 
%   Ld= [Ld zeros(nd,k); zeros(n,kd) L]; 
%   [nd kd]=size(Cdk); 
%   Cdk= [Cdk zeros(nd,kc); zeros(nc,kd) Ck]; 
% end
% 

% --- CONSTRAINT DEFINITION ---------------------------
% --- CONSTRAINT DEFINITION ---------------------------
% --- CONSTRAINT DEFINITION ---------------------------

% CONTRAINT ANTI SKEW
Csk{1}=zeros(3,10);
Csk{2}=zeros(3,10);
Csk{3}=zeros(3,10);
Csk{4}=[zeros(3,6) [ 0 1 0; 0 0 1; 0 0 0] zeros(3,1)];
Csk{5}=[zeros(3,6) [ 1 0  0; 0 0 0; 0 0 1] zeros(3,1)];
Csk{6}=[zeros(3,6) [ 0 0  0; 1 0 0; 0 1 0] zeros(3,1)];
% Cskn=[]; for i=1:6 Cskn=[Cskn Csk{i}]; end

% CONTRAINT IDENTITY
clear Cid;
for i=1:3 Cid{i}=zeros(3,10); Cid{i}(i,6+i)=-1; end
for i=4:6 Cid{i}=zeros(3,10); end
% Cidn=[]; for i=1:6 Cidn=[Cidn Cid{i}]; end

% CONTRAINT Zero
clear Cz;
for i=1:6 Cz{i}=zeros(9,10);  end
Cz{1}(1,8)=1;
Cz{1}(2,9)=1;
Cz{2}(3,7)=1;
Cz{2}(4,9)=1;
Cz{3}(5,7)=1;
Cz{3}(6,8)=1;
Cz{4}(7,7)=1;
Cz{5}(8,8)=1;
Cz{6}(9,9)=1;
% Czn=[]; for i=1:6 Czn=[Czn Cz{i}]; end

% CONTRAINT Pos Y
for i=1:6 Cy{i}=zeros(1,10);  end
Cy{4}(1,8)=-1;
% Cyn=[]; for i=1:6 Cyn=[Cyn Cy{i}]; end

Cn=[]; for i=1:6 C{i}=[ Csk{i}; Cid{i} ; Cz{i} ; Cy{i} ]; Cn=[Cn C{i}]; end


% --- OPTIMISATION PROBLEM ---------------------------------------
% --- OPTIMISATION PROBLEM ---------------------------------------
% --- OPTIMISATION PROBLEM ---------------------------------------

LtL=L'*L+10*Ck;
LtLi=pinv(LtL);
Sm=0; for i=1:6 Sm=Sm-C{i}*LtLi*C{i}'; end;
Si=inv(Sm);
MCS=[]; for i=1:6 MCS=[MCS; -LtLi*C{i}'*Si ]; end

% --- INVERSE OPTIMIZATION --------------------------------------
% --- INVERSE OPTIMIZATION --------------------------------------
% --- INVERSE OPTIMIZATION --------------------------------------

for i=1:6
  for j=1:6
    CSC((i-1)*10+1:i*10,(j-1)*10+1:j*10)=LtLi*C{i}'*Si*C{j}*LtLi;
    if( i==j ) 
       MCSCM((i-1)*10+1:i*10,(j-1)*10+1:j*10)=LtLi*C{i}'*Si*C{j}*LtLi+LtLi;
    else MCSCM((i-1)*10+1:i*10,(j-1)*10+1:j*10)=LtLi*C{i}'*Si*C{j}*LtLi;
    end;
end; end
% Ti=[MCSCM MCS; MCS' Si];
Ti=[MCSCM MCS];
iK=reshape([sVh;zeros(4,6)],60,1);
ysol=Ti*[ 10*iK; Cn*y ];
Ysol=reshape(ysol,10,6);

% --- PARAMETER SELECTION ---------------------------------------

Kqp=sVh*Ysol(1:6,1:6)';
gammaqp=inv(sVh)*inv(Kqp)*sVh*Ysol(end,:)';
scqp=[Ysol(9,5);  Ysol(7,6); Ysol(8,4)];
Skqp=[ 0 -scqp(3) scqp(2); scqp(3) 0 -scqp(1); -scqp(2) scqp(1) 0];


betaqp=inv(sVh)*Kqp*sVh*gammaqp;
Xqp=[eye(3) ;Skqp];
Ytqp=[ inv(sVh)*Kqp -Xqp betaqp ];
Yqp=Ytqp';


paramsqp=[ scqp'  gammaqp' reshape(Kqp-eye(6),1,36)];
nerr=calibTorsor(fred,rqred,paramsDefaultOrder,paramsDefault,{'sc','gamma6','gain36'},paramsqp,opts);
