function [nerr sRh sc mg gamma K Sk_sc ] = calibTorsor( fs,Rqs,paramsDefaultOrder,paramsDefault,paramsOptOrder,paramsOpt,opts );
argc=nargin;
if( argc==2 ) opts=''; end
if( argc==3 ) 
     opts=paramsDefaultOrder;  paramsDefaultOrder={}; paramsDefault=[];
     paramsOptOrder={}; paramsOpt=[];
end
if( argc==4 ) 
     opts=''; paramsOptOrder={}; paramsOpt=[];
end
if( argc==5 ) 
     opts=paramsOptOrder; paramsOptOrder={}; paramsOpt=[];
end
if( argc==6 ) 
     opts='';
end


uteta_sRh=[0 0 -pi/2]; 
sc=[0 0 -0.05];  
mg=[ 0;0;-8]; 
gamma_f=mg;
gamma_tau=0;
gains=zeros(6);
fact_f=1; fact_tau=1; fact_gain=2.5;

params=paramsDefault; 
paramsOrder=paramsDefaultOrder;
for twopass=1:2
curs=1;
for i=1:length(paramsOrder)
     if strcmp(paramsOrder(i),'sRh') 
       uteta_sRh=params(curs:curs+2)'; curs=curs+3;
     end
     if strcmp(paramsOrder(i),'sc') 
       sc=params(curs:curs+2)'; curs=curs+3;
     end
     if strcmp(paramsOrder(i),'mg') 
       mg=[0;0;params(curs)]; curs=curs+1;
     end
     if strcmp(paramsOrder(i),'mg3') 
       mg=params(curs:curs+2)'; curs=curs+3;
     end
     if strcmp(paramsOrder(i),'gamma6') 
       gamma_f=params(curs:curs+2)'; curs=curs+3;
       gamma_tau=params(curs:curs+2)'; curs=curs+3;
     end
     if strcmp(paramsOrder(i),'gammaf') 
       gamma_f=params(curs:curs+2)'; curs=curs+3;
     end
     if strcmp(paramsOrder(i),'gammatau') 
       gamma_tau=params(curs:curs+2)'; curs=curs+3;
     end
     if strcmp(paramsOrder(i),'gain36') 
       gains=gains+reshape(params(curs:curs+35),6,6);
       curs=curs+36;
     end
     if strcmp(paramsOrder(i),'gain18') 
       Kf=reshape(params(curs:curs+8),3,3); curs=curs+9;
       Ktau=reshape(params(curs:curs+8),3,3); curs=curs+9;
       gains=gains+[Kf zeros(3); zeros(3) Ktau];
     end
     if strcmp(paramsOrder(i),'gain6') 
       gains=gains+diag(params(curs:curs+5)); curs=curs+6;
     end
     if strcmp(paramsOrder(i),'gainf9') 
       Ktau=reshape(params(curs:curs+8),3,3); curs=curs+9;
       gains=gains+[Kf zeros(3); zeros(3) zeros(3)];
     end
     if strcmp(paramsOrder(i),'gaintau9') 
       Ktau=reshape(params(curs:curs+8),3,3); curs=curs+9;
       gains=gains+[zeros(3) zeros(3); zeros(3) Ktau];
     end
     if strcmp(paramsOrder(i),'gaintau3') 
       Ktau=diag(params(curs:curs+2)); curs=curs+3;
       gains=gains+[zeros(3) zeros(3); zeros(3) Ktau];
     end
     if strcmp(paramsOrder(i),'gainf3') 
       Kf=diag(params(curs:curs+2)); curs=curs+3;
       gains=gains+[Kf zeros(3); zeros(3) zeros(3)];
     end
     if strcmp(paramsOrder(i),'normf') 
       fact_f=params(curs); curs=curs+1;
     end
     if strcmp(paramsOrder(i),'normtau') 
       fact_tau=params(curs); curs=curs+1;
     end
     if strcmp(paramsOrder(i),'normgain') 
       fact_gain=params(curs); curs=curs+1;
     end
end
params=paramsOpt;
paramsOrder=paramsOptOrder;
end

sRh=tomatrix(uteta_sRh);
K=gains+eye(6);
Sk_sc=[ 0 -sc(3) sc(2); sc(3) 0 -sc(1); -sc(2) sc(1) 0];
if(gamma_tau==0) gamma_tau=-Sk_sc*mg; end;
gamma=[gamma_f;gamma_tau];
sVh=[sRh zeros(3);zeros(3) sRh];

% --- MINIMISATION ----------------------------------------------
for i=1:length(Rqs) 
    hRw=reshape(Rqs(i,[1:3 5:7 9:11]),3,3);
    torsred=fs(i,:)';
    hXw=[hRw;Sk_sc*hRw];
    sXw=sVh*hXw;
    err(i,:)=(K*(torsred+sVh*gamma)-sXw*mg);
end;

nerr=sqrt( fact_f*norm(err(:,1:3))^2 + fact_tau*norm(err(:,4:6))^2 );
nerr=nerr+norm(gains)*fact_gain;
% --- / MINIMISATION --------------------------------------------

if (strcmp(opts,'plot'))
    %subplot(2,1,1); plot(fs); title('F non comp');
    %subplot(2,1,2); 
    plot(err); title('F comp');
end;
if (strcmp(opts,'plot2'))
    subplot(2,2,1); plot(fs(:,1:3)); title('F non comp');
    subplot(2,2,3); plot(err(:,1:3)); title('F comp');
    subplot(2,2,2); plot(fs(:,4:6)); title('Tau non comp');
    subplot(2,2,4); plot(err(:,4:6)); title('Tau comp');
end;
if (strcmp(opts,'disp'))
    disp(sRh); disp(sc); disp(mg); disp(gamma); disp(K);
end;
if (strcmp(opts,'dispSot'))
     disp('');
     disp(dispMatrix(sRh','handRsensor'));
     disp(dispVector(sc,'sensorCom'));
     disp(dispVector([mg;0;0;0],'gravity'));
     disp(dispVector(sVh*gamma,'precompensation'));
     disp(dispMatrix(K,'gain'));
end;

function [str] = dispMatrix( hRs,name )
     sz=size(hRs);
     str=sprintf('set %s [%d,%d]((',name,sz(1),sz(2));
     for i=1:sz(1) for j=1:sz(2) 
          if(j<sz(2)) sep=','; else if(i<sz(1)) sep='),('; else sep='))'; end; end;
     str=sprintf('%s%f%s',str,hRs(i,j),sep);  end;  end;

function [str] = dispVector( hRs,name )
     sz=length(hRs);
     str=sprintf('set %s [%d](',name,sz);
     for i=1:sz
          if(i<sz) sep=','; else sep=')'; end;
          str=sprintf('%s%f%s',str,hRs(i),sep);  
     end;  

