function [ rotmat ]  = tomatrix( uteta )

% Passage from UTETA vector (3 parameters) to rotation matrix

MINSIN=1e-8;
MINCOS=2.5e-4;

theta = norm(uteta);
si = sin(theta);
co = cos(theta);
if( abs(theta)>MINSIN) sinc = si/theta; else sinc = 1; end;
if( abs(theta)>MINCOS) cosc = (1-co)/(theta*theta); else cosc=.5;end;

rotmat(1,1) = co + cosc*uteta(1)*uteta(1);
rotmat(1,2) = -sinc*uteta(3) + cosc*uteta(1)*uteta(2);
rotmat(1,3) = sinc*uteta(2) + cosc*uteta(1)*uteta(3);
rotmat(2,1) = sinc*uteta(3) + cosc*uteta(2)*uteta(1);
rotmat(2,2) = co + cosc*uteta(2)*uteta(2);
rotmat(2,3) = -sinc*uteta(1) + cosc*uteta(2)*uteta(3);
rotmat(3,1) = -sinc*uteta(2) + cosc*uteta(3)*uteta(1);
rotmat(3,2) = sinc*uteta(1) + cosc*uteta(3)*uteta(2);
rotmat(3,3) = co + cosc*uteta(3)*uteta(3);



