        
# Specific to HRP-2
import hrp
import hstsetup
from hrp import *

# ---------------------------------------------------------------------------- #
# --- LOADING THE PLUGINS ---------------------------------------------------- #
# ---------------------------------------------------------------------------- #

ms = findPluginManager("motionsys")


# ---
# --- CLASSICAL PLUGIN: filter, ZMP, Seq.
# ---
ms.load("kfplugin")
kf = ms.create("kfplugin","kf","")
kf.start()

ms.load("seqplay")
seq = SequencePlayerHelper.narrow(ms.create("seqplay","seq","-ORBconfig../../../../../Common/orb.conf"))
seq.start()

# ---
# --- VISUAL SERVOING
# ---
#waitInput("Wait before loading SOT plugin.");
ms.load("StackOfTasks")
sot = ms.create("StackOfTasks","sot","")


# -------------------------------------------------------------------------
#seq.goHalfSitting(2.5)
#seq.sendMsg(":joint-angles 0 0 -20 40 -20 0                                                                          0 0 -20 40 -20 0                                                                          0 0                                                                                      -0 0                                                                                       10 -10 -10 -70 0 -0 10                                                                    10  10 10 -70 0 0 10                                                                    -10.0 10.0 -10.0 10.0 -10.0 -10.0 10.0 -10.0 10.0 -10.0  3.5")
seq.sendMsg(":joint-angles 0 0 -20 40 -20 0                                                                          0 0 -20 40 -20 0                                                                          0 0                                                                                      -0 0                                                                                       0 -0 -0 -0 0 -0 10                                                                    10  10 10 -70 0 0 10                                                                    -10.0 10.0 -10.0 10.0 -10.0 -10.0 10.0 -10.0 10.0 -10.0  3.5")

seq.waitInterpolation()

# -------------------------------------------------------------------------
#waitInputConfirm("Wait before sot init.")
sot.sendMsg(":init");

#waitInputConfirm("Wait before script loading.")

sot.sendMsg(":script run /home/nmansard/src/StackOfTasks/script/dyn")
sot.sendMsg(":script run /home/nmansard/src/StackOfTasks/script/coshell")
sot.sendMsg(":script run /home/nmansard/src/StackOfTasks/script/traces")

sot.sendMsg(":script plug OpenHRP.state dyn.position")
sot.sendMsg(":script plug OpenHRP.state dyn2.position")
sot.sendMsg(":script plug OpenHRP.attitude posKF.attitudeIN")
sot.sendMsg(":script plug OpenHRP.attitude flex.sensorWorldRotation")
sot.sendMsg(":script plug sot.control OpenHRP.control")

sot.sendMsg(":script run /home/nmansard/src/StackOfTasks/script/small")
sot.sendMsg(":script run /home/nmansard/src/StackOfTasks/script/jointlimit")

sot.sendMsg(":script OpenHRP.pause")
sot.start()

sot.sendMsg(":script run /home/nmansard/src/StackOfTasks/script/calib")

with_trace=waitInputSelect("Wait before sot play.\nPress [Yes] to start the tracer by the way [No] to simply start. ")
sot.sendMsg(":script OpenHRP.reinit from mc")
sot.sendMsg(":script OpenHRP.play")
if(with_trace):
      sot.sendMsg(":script tr.start")

# ----- FORCE CALIBRATION --------------
# ----- FORCE CALIBRATION --------------
# ----- FORCE CALIBRATION --------------

#sot.sendMsg(":script run /home/nmansard/src/StackOfTasks/script/precalib")


waitInputConfirm("Next stage [0/24].")
sot.sendMsg(":script calibThenMov 25 -0")
waitInputConfirm("Next stage [1/24].")
sot.sendMsg(":script calibThenMov 25 -0.3491")
waitInputConfirm("Next stage [2/24].")
sot.sendMsg(":script calibThenMov 25 -1.0472")
waitInputConfirm("Next stage [3/24].")
sot.sendMsg(":script calibThenMov 25 -1.5708")
waitInputConfirm("Next stage [4/24].")
sot.sendMsg(":script calibThenMov 25 -2.0944")
waitInputConfirm("Next stage [5/24].")
sot.sendMsg(":script calibThenMov 25 -2.3562")
waitInputConfirm("Next stage [6/24].")
sot.sendMsg(":script calibThenMov 26 -1.0472")
waitInputConfirm("Next stage [7/24].")
sot.sendMsg(":script calibThenMov 26 -1.5708")
waitInputConfirm("Next stage [8/24].")
sot.sendMsg(":script calibThenMov 25 -1.5708")
waitInputConfirm("Next stage [9/24].")
sot.sendMsg(":script calibThenMov 25 -1.0472")
waitInputConfirm("Next stage [10/24].")
sot.sendMsg(":script calibThenMov 25 -0.3491")
waitInputConfirm("Next stage [11/24].")
sot.sendMsg(":script calibThenMov 25 0")

waitInputConfirm("Next stage [12/24].")
sot.sendMsg(":script calibThenMov 24 -1")

waitInputConfirm("Next stage [13/24].")
sot.sendMsg(":script calibThenMov 25 -0.3491")
waitInputConfirm("Next stage [14/24].")
sot.sendMsg(":script calibThenMov 25 -1.0472")
waitInputConfirm("Next stage [15/24].")
sot.sendMsg(":script calibThenMov 25 -1.5708")
waitInputConfirm("Next stage [16/24].")
sot.sendMsg(":script calibThenMov 25 -2.0944")
waitInputConfirm("Next stage [17/24].")
sot.sendMsg(":script calibThenMov 25 -2.3562")
waitInputConfirm("Next stage [18/24].")
sot.sendMsg(":script calibThenMov 26 -1.0472")
waitInputConfirm("Next stage [19/24].")
sot.sendMsg(":script calibThenMov 26 -1.5708")
waitInputConfirm("Next stage [20/24].")
sot.sendMsg(":script calibThenMov 25 -1.5708")
waitInputConfirm("Next stage [21/24].")
sot.sendMsg(":script calibThenMov 25 -1.0472")
waitInputConfirm("Next stage [22/24].")
sot.sendMsg(":script calibThenMov 25 -0.3491")
waitInputConfirm("Next stage [23/24].")
sot.sendMsg(":script calibThenMov 25 0")

waitInputConfirm("Last stage [24/24].")
sot.sendMsg(":script calibThenMov 25 0")

waitInputConfirm("Next stage: calibration and task3d completion.")
#sot.sendMsg(":script run /home/nmansard/src/StackOfTasks/script/postcalib")

# -------------------------------------------------------------------------
with_trace=waitInputSelect("Wait before sot stop.\nPress [Yes] to force the trace by the way [No] to simply stop.")
sot.sendMsg(":hold")
# Careful! The SOT plugin should not be stopped before seqplay has ended its
# motion. waitInterpolation should block the script. If not, don't push [OK] to
# the next dialog box before the robot has reached the 1/2seating
if(with_trace):
      sot.sendMsg(":script tr.trace")
sot.sendMsg(":waitForFinished")

# -------------------------------------------------------------------------
#waitInputConfirm("Wait before sot stop.")
sot.stop()

# -------------------------------------------------------------------------
waitInputConfirm("Wait before sot unloads and script ends.")
sot.sendMsg(':profile')
ms.sendMsg(":destroy sot")
ms.sendMsg(":unload StackOfTasks")

print("Script finished")


