        
# Specific to HRP-2
import hrp
import hstsetup
from hrp import *

# ---------------------------------------------------------------------------- #
# --- LOADING THE PLUGINS ---------------------------------------------------- #
# ---------------------------------------------------------------------------- #

ms = findPluginManager("motionsys")


# ---
# --- CLASSICAL PLUGIN: filter, ZMP, Seq.
# ---
ms.load("kfplugin")
kf = ms.create("kfplugin","kf","")
#ms.load("ZMPsensor")
#zmpsensor = ms.create("ZMPsensor","zmpsensor","")
kf.start()

ms.load("seqplay")
seq = seqpluginHelper.narrow(ms.create("seqplay","seq","-ORBconfig../../../../../Common/orb.conf"))
seq.start()

# ---
# --- VISUAL SERVOING
# ---
#waitInput("Wait before loading VS plugin.");
ms.load("StackOfTasks")
vs = ms.create("StackOfTasks","vs","")

# ---
# --- STABILIZER
# ---
#ms.load("hstabilizer")
#st = ms.create("hstabilizer","st","")

# ---
# --- LOG
# ---
ms.load("logplugin")
log = LoggerPluginHelper.narrow(ms.create("logplugin","log",""))
log.add("kf")
log.add("st")
log.sendMsg(":max-length 80")
log.start()

# -------------------------------------------------------------------------


# -------------------------------------------------------------------------

# -------------------------------------------------------------------------
#seq.goHalfSitting(2.5)
#BALLROSE seq.sendMsg(":joint-angles 0 0 -20 40 -20 0                                                                          0 0 -20 40 -20 0                                                                          0 0                                                                                      -0 0                                                                                       10 -10 -10 -80 0 -0 0                                                                     35 5 0 -20.0 0 0 10.0                                                                    -10.0 10.0 -10.0 10.0 -10.0 -10.0 10.0 -10.0 10.0 -10.0  2.5")
#seq.sendMsg(":joint-angles 0 0 -20 40 -20 0                                                                          0 0 -20 40 -20 0                                                                          0 0                                                                                      -0 0                                                                                       10 -10 -10 -70 0 -0 10                                                                    10  10 10 -70 0 0 10                                                                    -10.0 10.0 -10.0 10.0 -10.0 -10.0 10.0 -10.0 10.0 -10.0  2.5")
# Pose reference for fridge position 
#seq.sendMsg(":joint-angles 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 -18.8688 -12.6270 34.8805 -91.7976 -21.1161 10.1335 20 -56.7504 52.4196 -82.2802 -106.0912 65.2215 -12.3015 20 0 0 0 0 0 0 0 0 0 0 1.5")

seq.sendMsg(":joint-angles 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 48.7014 -14.3239 0 -83.0789 0 0 10 48.7014 14.3239 0 -83.0789 0 0 10 0 0 0 0 0 0 0 0 0 0 1.5")

seq.waitInterpolation()

#seq.stop()
#ms.sendMsg(":destroy seq")
#ms.sendMsg(":unload seqplay")

# -------------------------------------------------------------------------

#waitInputConfirm("Wait before vs init.")
vs.sendMsg(":init");

#waitInputConfirm("Wait before script loading.")

vs.sendMsg(":script run /home/nmansard/src/StackOfTasks/script/dyn")
vs.sendMsg(":script run /home/nmansard/src/StackOfTasks/script/coshell")
vs.sendMsg(":script run /home/nmansard/src/StackOfTasks/script/traces")

# --- Use/ignore force sensors
vs.sendMsg(":script plug OpenHRP.state dyn.position")
vs.sendMsg(":script plug OpenHRP.state dyn2.position")
vs.sendMsg(":script plug OpenHRP.attitude posKF.attitudeIN")
vs.sendMsg(":script plug OpenHRP.attitude attitudeSensor.in")
vs.sendMsg(":script plug sot.control OpenHRP.control")
vs.sendMsg(":script plug OpenHRP.attitude attitudeSensor.in")

#vs.sendMsg(":script run /home/nmansard/src/StackOfTasks/script/debug")
vs.sendMsg(":script run /home/nmansard/src/StackOfTasks/script/force")
vs.sendMsg(":script run /home/nmansard/src/StackOfTasks/script/forceL")
vs.sendMsg(":script run /home/nmansard/src/StackOfTasks/script/small")
vs.sendMsg(":script run /home/nmansard/src/StackOfTasks/script/jointlimit")

vs.sendMsg(":script run /home/nmansard/src/StackOfTasks/script/grip")
vs.sendMsg(":script run /home/nmansard/src/StackOfTasks/script/frigo")

vs.sendMsg(":script OpenHRP.pause")

#waitInputConfirm("Wait before vs start.")
vs.start()

# -------------------------------------------------------------------------

with_trace=waitInputSelect("Wait before vs play.\nPress [Yes] to start the tracer by the way [No] to simply start. ")
vs.sendMsg(":script OpenHRP.reinit from mc")
vs.sendMsg(":script OpenHRP.play")
if(with_trace):
      vs.sendMsg(":script tr.start")
# -------------------------------------------------------------------------

waitInputConfirm("Ready for the seqplay")

vs.sendMsg(":script OpenHRP.withPreviousControl 1")
vs.sendMsg(":script plug OpenHRP.previousControl OpenHRP.control")

      
# Position at introduction of task T1a__RIGHT_ARM_TASK_FRIDGE_UP
#seq.sendMsg(":joint-angles 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 25.8614 -8.60073 0.0283959 -43.1482 -0.0240808 0.0467002 0 25.7831 8.59437 0 -42.9718 0 0 0 0 0 0 0 0 0 0 0 0 0")
#seq.waitInterpolation()
#waitInputConfirm("Ready to start Task T1a__RIGHT_ARM_TASK_FRIDGE_UP")


# Position at introduction of task T0__RIGHT_HAND_TASK_OPENING
#seq.sendMsg(":joint-angles 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 36.3851 -10.1153 4.32558 -69.6193 -2.5603 5.27471 0.304856 25.7831 8.59437 0 -42.9718 0 0 0 -0.304856 0.304856 -0.304856 0.304856 -0.304856 0 0 0 0 0")
#seq.waitInterpolation()
#waitInputConfirm("Ready to start Task T0__RIGHT_HAND_TASK_OPENING")


# Position at introduction of task T5__LEFT_HAND_TASK_OPENING
#seq.sendMsg(":joint-angles 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 -0.999633 -10.4635 32.3588 -108.518 -9.65993 13.6742 44.8517 25.7831 8.59437 0 -42.9718 0 0 -0.188897 -44.8517 44.8517 -44.8517 44.8517 -44.8517 0.188897 -0.188897 0.188897 -0.188897 0.188897")
#seq.waitInterpolation()
#waitInputConfirm("Ready to start Task T5__LEFT_HAND_TASK_OPENING")


# Position at introduction of task T1__RIGHT_ARM_TASK_FRIDGE_UP
# seq.sendMsg(":joint-angles 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 -1.18957 -10.3322 32.3942 -108.313 -9.64914 13.6946 44.8517 25.7831 8.59437 0 -42.9718 0 0 -38.9488 -44.8517 44.8517 -44.8517 44.8517 -44.8517 38.9488 -38.9488 38.9488 -38.9488 38.9488")
# seq.waitInterpolation()
# waitInputConfirm("Ready to start Task T1__RIGHT_ARM_TASK_FRIDGE_UP")


# Position at introduction of task T2__RIGHT_HAND_TASK_CLOSING
#seq.sendMsg(":joint-angles 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 -10.4819 -3.91823 33.6973 -97.0428 -9.28237 13.5057 44.4883 25.7831 8.59437 0 -42.9718 0 0 -44.7357 -44.4883 44.4883 -44.4883 44.4883 -44.4883 44.7357 -44.7357 44.7357 -44.7357 44.7357")
#seq.waitInterpolation()
#waitInputConfirm("Ready to start Task T2__RIGHT_HAND_TASK_CLOSING")


# Position at introduction of task T3__RIGHT_ARM_TASK_FRIDGE_UP_OPENING
# seq.sendMsg(":joint-angles 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 -10.4434 -3.96486 33.6919 -97.1046 -9.30004 13.5097 9.21804 25.7831 8.59437 0 -42.9718 0 0 -44.9558 -9.21804 9.21804 -9.21804 9.21804 -9.21804 44.9558 -44.9558 44.9558 -44.9558 44.9558")
# seq.waitInterpolation()
# waitInputConfirm("Ready to start Task T3__RIGHT_ARM_TASK_FRIDGE_UP_OPENING")


# Position at introduction of task T6__LEFT_ARM_TASK
#seq.sendMsg(":joint-angles 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 -105.117 -57.6575 167.871 -111.297 -64.8819 -62.4854 9 25.9093 8.58729 -0.0249264 -43.2868 0.0101711 0.125063 -45 -9 9 -9 9 -9 45 -45 45 -45 45")
#seq.waitInterpolation()
#waitInputConfirm("Ready to start Task T6__LEFT_ARM_TASK")


# Position at introduction of task T7__LEFT_ARM_TASK_CAN
# seq.sendMsg(":joint-angles 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 -105.457 -56.9189 168.664 -111.139 -65.1313 -63.2475 9 -18.5405 3.56083 -35.1916 -114.911 16.9374 37.3318 -45 -9 9 -9 9 -9 45 -45 45 -45 45")
# seq.waitInterpolation()
# waitInputConfirm("Ready to start Task T7__LEFT_ARM_TASK_CAN")


# Position at introduction of task T8__LEFT_HAND_TASK_CLOSING
#seq.sendMsg(":joint-angles 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 -105.458 -56.9168 168.667 -111.138 -65.1319 -63.2499 9 -22.6626 -3.29894 -43.0768 -85.7227 13.3922 14.3747 -44.4177 -9 9 -9 9 -9 44.4177 -44.4177 44.4177 -44.4177 44.4177")
#seq.waitInterpolation()
#waitInputConfirm("Ready to start Task T8__LEFT_HAND_TASK_CLOSING (ie we are at pos can)")


# Position at introduction of task T9__LEFT_ARM_TASK_MOVETO
# seq.sendMsg(":joint-angles 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 -105.458 -56.9168 168.667 -111.138 -65.1319 -63.25 9 -22.6626 -3.29894 -43.0768 -85.7227 13.3922 14.3747 -9.26913 -9 9 -9 9 -9 9.26913 -9.26913 9.26913 -9.26913 9.26913")
# seq.waitInterpolation()
# waitInputConfirm("Ready to start Task T9__LEFT_ARM_TASK_MOVETO (ie LH at pos can)")


# Position at introduction of task T9b__LEFT_ARM_TASK_MOVETO
# seq.sendMsg(":joint-angles 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 -105.458 -56.9168 168.667 -111.138 -65.1319 -63.25 9 -29.0161 -8.58111 -37.9799 -96.0479 13.5589 33.4561 -9 -9 9 -9 9 -9 9 -9 9 -9 9")
# seq.waitInterpolation()
# waitInputConfirm("Ready to start Task T9b__LEFT_ARM_TASK_MOVETO (ie LH up to the can, inter1)")


# Position at introduction of task T10__LEFT_ARM_TASK
# seq.sendMsg(":joint-angles 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 -105.458 -56.9168 168.667 -111.138 -65.1319 -63.25 9 -27.8818 13.1246 -34.1539 -109.513 30.7714 33.1092 -9 -9 9 -9 9 -9 9 -9 9 -9 9")
# seq.waitInterpolation()
# waitInputConfirm("Ready to start Task T10__LEFT_ARM_TASK (ie LH out of the fridge, inter2")


# Position at introduction of task T4__RIGHT_ARM_TASK_FRIDGE_UP_CLOSING
seq.sendMsg(":joint-angles 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 -105.443 -56.9227 168.638 -111.14 -65.131 -63.2299 9 66.9732 13.4105 -1.11615 -82.8933 15.4305 -74.1344 9 9 9 9 9 9 9 9 9 9 9 2.5")
seq.waitInterpolation()
waitInputConfirm("Ready to start Task T4__RIGHT_ARM_TASK_FRIDGE_UP_CLOSING (ie RH at fridge operture max")

# -------------------------------------------------------------------------
with_trace=waitInputSelect("Wait before vs stop.\nPress [Yes] to force the trace by the way [No] to simply stop.")
vs.sendMsg(":hold")
# Careful! The VS plugin should not be stopped before seqplay has ended its
# motion. waitInterpolation should block the script. If not, don't push [OK] to
# the next dialog box before the robot has reached the 1/2seating
if(with_trace):
      vs.sendMsg(":script tr.trace")
vs.sendMsg(":waitForFinished")

# -------------------------------------------------------------------------
#waitInputConfirm("Wait before vs stop.")
vs.stop()

# -------------------------------------------------------------------------
#waitInputConfirm("Wait before vs unload.")
vs.sendMsg(':profile')
ms.sendMsg(":destroy vs")
ms.sendMsg(":unload StackOfTasks")

# --- 
# --- LOGS
# --- 
waitInputConfirm("Wait before log")
log.stop()
log.save("sim")

print("Script finished")


