        
# Specific to HRP-2
import hrp
import hstsetup
from hrp import *

# ---------------------------------------------------------------------------- #
# --- LOADING THE PLUGINS ---------------------------------------------------- #
# ---------------------------------------------------------------------------- #

ms = findPluginManager("motionsys")


# ---
# --- CLASSICAL PLUGIN: filter, ZMP, Seq.
# ---
ms.load("kfplugin")
kf = ms.create("kfplugin","kf","")
#ms.load("ZMPsensor")
#zmpsensor = ms.create("ZMPsensor","zmpsensor","")
kf.start()

ms.load("seqplay")
seq = SequencePlayerHelper.narrow(ms.create("seqplay","seq","-ORBconfig../../../../../Common/orb.conf"))
seq.start()

# ---
# --- VISUAL SERVOING
# ---
#waitInput("Wait before loading VS plugin.");
ms.load("StackOfTasks")
vs = ms.create("StackOfTasks","vs","")

# ---
# --- STABILIZER
# ---
ms.load("hstabilizer")
st = ms.create("hstabilizer","st","")
# st.start

# ---
# --- LOG
# ---
ms.load("logplugin")
log = LoggerPluginHelper.narrow(ms.create("logplugin","log",""))
log.add("kf")
log.add("st")
log.sendMsg(":max-length 80")
log.start()

# --- Specific to walking --- #
hstsetup.stsetup(st)
kf.start()
st.start()

# -------------------------------------------------------------------------

#INIT TELEOP
rleg_a = "0 0 -20 40 -20 0"
lleg_a = "0 0 -20 40 -20 0"
chest_a = "0 0"
head_a = "0 0"
rarm_a = "10 -10 0 -100 -10 0 10" # <-- ballrose: "10 -10 -10 -80 0 -0 0", dunnowhat: "10 -10 -10 -70 0 -0 10"
larm_a = "10  10 0 -100  10 0 10" # <-- ballrose: "35 5 0 -20.0 0 0 10.0", dunnowhat: "10  10 10 -70 0 0 10"
rhand_a = "-10.0 10.0 -10.0 10.0 -10.0"
lhand_a = "-10.0 10.0 -10.0 10.0 -10.0"
#seq.sendMsg(":joint-angles "+rleg_a+" "+lleg_a+" "+chest_a+" "+head_a+" "+rarm_a+" "+larm_a+" "+rhand_a+" "+lhand_a+" 2.5")
seq.waitInterpolation()
#seq.stop()
#ms.sendMsg(":destroy seq")
#ms.sendMsg(":unload seqplay")

# -------------------------------------------------------------------------
#waitInputConfirm("Wait before vs init.")
vs.sendMsg(":init");

#waitInputConfirm("Wait before script loading.")

vs.sendMsg(":script run /home/nmansard/src/StackOfTasks/script/dyn")
vs.sendMsg(":script run /home/nmansard/src/StackOfTasks/script/coshell")
vs.sendMsg(":script run /home/nmansard/src/StackOfTasks/script/traces")

vs.sendMsg(":script plug OpenHRP.state dyn.position")
vs.sendMsg(":script plug OpenHRP.state dyn2.position")
vs.sendMsg(":script plug OpenHRP.attitude posKF.attitudeIN")
vs.sendMsg(":script plug OpenHRP.attitude flex.sensorWorldRotation")
vs.sendMsg(":script plug sot.control OpenHRP.control")

vs.sendMsg(":script run /home/nmansard/src/StackOfTasks/script/force")
vs.sendMsg(":script run /home/nmansard/src/StackOfTasks/script/forceL")
vs.sendMsg(":script run /home/nmansard/src/StackOfTasks/script/small")
vs.sendMsg(":script run /home/nmansard/src/StackOfTasks/script/jointlimit")

vs.sendMsg(":script run /home/nmansard/src/StackOfTasks/script/grip")

#vs.sendMsg(":script run /home/nmansard/src/StackOfTasks/script/debug")

vs.sendMsg(":script OpenHRP.pause")

#waitInputConfirm("Wait before vs start.")
vs.start()

# DEBUG: uncomment next 2
waitInputConfirm("Started ... Wait to config the teleop.")
vs.sendMsg(":script run /home/nmansard/src/StackOfTasks/script/teleoperation/teleop")

vs.sendMsg(":script run /home/nmansard/src/StackOfTasks/script/hwpg")
vs.sendMsg(":script run /home/nmansard/src/StackOfTasks/script/walking/hwpgjoints")

with_trace=waitInputSelect("Wait before vs play.\nPress [Yes] to start the tracer by the way [No] to simply start. ")
vs.sendMsg(":script OpenHRP.reinit from mc")
vs.sendMsg(":script OpenHRP.play")
if(with_trace):
      vs.sendMsg(":script tr.start")

# -------------------------------------------------------------------------
with_trace=waitInputSelect("Wait before vs stop.\nPress [Yes] to force the trace by the way [No] to simply stop.")
vs.sendMsg(":hold")
# Careful! The VS plugin should not be stopped before seqplay has ended its
# motion. waitInterpolation should block the script. If not, don't push [OK] to
# the next dialog box before the robot has reached the 1/2seating
if(with_trace):
      vs.sendMsg(":script tr.trace")
vs.sendMsg(":waitForFinished")

# -------------------------------------------------------------------------
#waitInputConfirm("Wait before vs stop.")
vs.stop()

# -------------------------------------------------------------------------
#waitInputConfirm("Wait before vs unload.")
vs.sendMsg(':profile')
ms.sendMsg(":destroy vs")
ms.sendMsg(":unload StackOfTasks")

# --- 
# --- LOGS
# --- 
waitInputConfirm("Wait before log")
log.stop()
log.save("sim")

print("Script finished")


