        
# Specific to HRP-2
import hrp
import hstsetup
from hrp import *

# ---------------------------------------------------------------------------- #
# --- LOADING THE PLUGINS ---------------------------------------------------- #
# ---------------------------------------------------------------------------- #

ms = findPluginManager("motionsys")


# ---
# --- CLASSICAL PLUGIN: filter, ZMP, Seq.
# ---
ms.load("kfplugin")
kf = ms.create("kfplugin","kf","")
ms.load("ZMPsensor")
zmpsensor = ms.create("ZMPsensor","zmpsensor","")

ms.load("seqplay")
seq = seqpluginHelper.narrow(ms.create("seqplay","seq","-ORBconfig../../../../../Common/orb.conf"))
seq.start()

# ---
# --- PATTERN GENERATOR
# ---
#waitInput("Wait before loading WALK plugin.");
ms.load("WalkGenJRL")
walk = ms.create("WalkGenJRL","walk","PreviewControlParameters.ini /home/nmansard/src/OpenHRP/etc/HRP2JRL/ HRP2JRLmain.wrl HRP2Specificities.xml HRP2LinkJointRank.xml")


# ---
# --- VISUAL SERVOING
# ---
#waitInput("Wait before loading VS plugin.");
ms.load("StackOfTasks")
vs = ms.create("StackOfTasks","vs","")

# ---
# --- STABILIZER
# ---
ms.load("hstabilizer")
st = ms.create("hstabilizer","st","")

# ---
# --- LOG
# ---
ms.load("logplugin")
log = LoggerPluginHelper.narrow(ms.create("logplugin","log",""))
log.add("kf")
log.add("st")
log.sendMsg(":max-length 80")
log.start()

# ---------------------------------------------------------------------------- #
# --- CONFIG THE PLUGINS ----------------------------------------------------- #
# ---------------------------------------------------------------------------- #

# --- SEQ PLAY -------------------------------------------------------------------
#seq.goHalfSitting(2.5)
#BALLROSE seq.sendMsg(":joint-angles 0 0 -20 40 -20 0                                                                          0 0 -20 40 -20 0                                                                          0 0                                                                                      -0 0                                                                                       10 -10 -10 -80 0 -0 0                                                                     35 5 0 -20.0 0 0 10.0                                                                    -10.0 10.0 -10.0 10.0 -10.0 -10.0 10.0 -10.0 10.0 -10.0  2.5")
#seq.sendMsg(":joint-angles 0 0 -20 40 -20 0                                                                          0 0 -20 40 -20 0                                                                          0 0                                                                                      -0 0                                                                                       10 -10 -10 -70 0 -0 10                                                                    10  10 10 -70 0 0 10                                                                    -10.0 10.0 -10.0 10.0 -10.0 -10.0 10.0 -10.0 10.0 -10.0  2.5")
seq.sendMsg(":joint-angles 0 0 -20 40 -20 0 0 0 -20 40 -20 0 0 0 -0 0 10 -10 0 -100 -10 0 10  10 10 0 -100 10 0 10 -10.0 10.0 -10.0 10.0 -10.0 -10.0 10.0 -10.0 10.0 -10.0  2.5")


seq.waitInterpolation()
hstsetup.stsetup()
kf.start()
zmpsensor.start()
st.start()

#seq.stop()
#ms.sendMsg(":destroy seq")
#ms.sendMsg(":unload seqplay")

# --- CONFIG THE WALK ------------------------------------------------------------
#waitInputConfirm("Wait before preparing stack step.")
walk.start()

walk.sendMsg(":parsecmd :omega 0.0")
walk.sendMsg(":parsecmd :stepheight 0.05")
walk.sendMsg(":parsecmd :singlesupporttime 0.78")
walk.sendMsg(":parsecmd :doublesupporttime 0.02")
walk.sendMsg(":parsecmd :armparameters 0.5")
walk.sendMsg(":parsecmd :LimitsFeasibility 0.0")
walk.sendMsg(":parsecmd :ZMPShiftParameters 0.015 0.015 0.015 0.015")
walk.sendMsg(":parsecmd :TimeDistributeParameters 2.0 3.5 1.0 3.0")
walk.sendMsg(":parsecmd :UpperBodyMotionParameters 0.0 -0.5 0.0")
walk.sendMsg(":parsecmd :SetAlgoForZmpTrajectory Kajita")

walk.sendMsg(":parsecmd :walkmode 0")

# Big step
#walk.sendMsg(":stepseq 0.0 -0.095 0.0 0.2 0.19 0.0 0.2 -0.19 0.0 0.2 0.19 0.0 0.2 -0.19 0.0 0.2 0.19 0.0 0.2 -0.19 0.0 0.2 0.19 0.0 0.2 -0.19 0.0 0.2 0.19 0.0 0.2 -0.19 0.0 0.2 0.19 0.0 0.2 -0.19 0.0 0.0 0.19 0.0")
# Small step
walk.sendMsg(":stepseq 0.0 -0.095 0.0 0.1 0.19 0.0 0.1 -0.19 0.0 0.1 0.19 0.0 0.1 -0.19 0.0 0.1 0.19 0.0 0.1 -0.19 0.0 0.0 0.19 0.0")
#Small steps
#walk.sendMsg(":stepseq 0.0 -0.095 0.0 0.1 0.19 0.0 0.1 -0.19 0.0 0.1 0.19 0.0 0.1 -0.19 0.0 0.1 0.19 0.0 0.1 -0.19 0.0 0.1 0.19 0.0 0.1 -0.19 0.0 0.1 0.19 0.0 0.1  -0.19 0.0 0.1 0.19 0.0 0.1  -0.19 0.0 0.1 0.19 0.0 0.1  -0.19 0.0 0.1 0.19 0.0 0.1  -0.19 0.0 0.1 0.19 0.0 0.1   -0.19 0.0 0.1 0.19 0.0 0.1  -0.19 0.0 0.1 0.19 0.0 0.1 -0.19 0.0 0.0 0.19 0.0")
# Arc
#walk.sendMsg(":parsecmd :supportfoot 1");
#walk.sendMsg(":parsecmd :arc 0.0 4 40.0 -1");
#walk.sendMsg(":parsecmd :lastsupport");
#walk.sendMsg(":parsecmd :finish");

#walk.sendMsg(":stepseq 0.0 -0.105 0.0 0.0 0.21 0.0 0.0 -0.21 0.0 0.0 0.21 0.0 0.0 -0.21 0.0 0.0 0.21 0.0 0.0 -0.21 0.0 0.0 0.21 0.0 0.0 -0.21 0.0 0.0 0.21 0.0 0.0 -0.21 0.0 0.0 0.21 0.0 0.0 -0.21 0.0 0.0 0.21 0.0 0.0 -0.21 0.0 0.0 0.21 0.0 0.0 -0.21 0.0 0.0 0.21 0.0 0.0 -0.21 0.0 0.0 0.21 0.0 0.0 -0.21 0.0 0.0 0.21 0.0")

# --- CONFIG THE SOT ---------------------------------------------------------------
#waitInputConfirm("Wait before vs init.")
vs.sendMsg(":init");

#waitInputConfirm("Wait before script loading.")
vs.sendMsg(":script run /home/nmansard/src/StackOfTasks/script/dyn")
vs.sendMsg(":script run /home/nmansard/src/StackOfTasks/script/coshell")
vs.sendMsg(":script run /home/nmansard/src/StackOfTasks/script/traces")
#vs.sendMsg(":script run /home/nmansard/src/StackOfTasks/script/flexibility")

vs.sendMsg(":script plug OpenHRP.state dyn.position")
vs.sendMsg(":script plug OpenHRP.state dyn2.position")
vs.sendMsg(":script plug OpenHRP.attitude posKF.attitudeIN")
vs.sendMsg(":script plug OpenHRP.attitude attitudeSensor.in")
vs.sendMsg(":script plug sot.control OpenHRP.control")
vs.sendMsg(":script plug OpenHRP.attitude attitudeSensor.in")

vs.sendMsg(":script run /home/nmansard/src/StackOfTasks/script/force")
vs.sendMsg(":script run /home/nmansard/src/StackOfTasks/script/forceL")
#vs.sendMsg(":script run /home/nmansard/src/StackOfTasks/script/selector")
vs.sendMsg(":script run /home/nmansard/src/StackOfTasks/script/grip")
vs.sendMsg(":script run /home/nmansard/src/StackOfTasks/script/walk")
vs.sendMsg(":script run /home/nmansard/src/StackOfTasks/script/small")
vs.sendMsg(":script run /home/nmansard/src/StackOfTasks/script/jointlimit")


vs.sendMsg(":script OpenHRP.pause")

#waitInputConfirm("Wait before vs start.")
vs.start()

# --- START THE PLUGINS ---------------------------------------------------
# --- START THE PLUGINS ---------------------------------------------------
# --- START THE PLUGINS ---------------------------------------------------

# --- SOT -----------------------------------------------------------------
with_trace=waitInputSelect("Wait before vs play.\nPress [Yes] to start the tracer by the way [No] to simply start. ")
vs.sendMsg(":script OpenHRP.reinit from mc")
vs.sendMsg(":script OpenHRP.play")
if(with_trace):
      vs.sendMsg(":script tr.start")

vs.sendMsg(":script run /home/nmansard/src/StackOfTasks/script/walkreact")

# --- WALK ----------------------------------------------------------------
#waitInputConfirm("Wait before walking.")
#walk.sendMsg(":SendStackToControl");


# -------------------------------------------------------------------------
with_trace=waitInputSelect("Wait before vs stop.\nPress [Yes] to force the trace by the way [No] to simply stop.")
vs.sendMsg(":hold")
# Careful! The VS plugin should not be stopped before seqplay has ended its
# motion. waitInterpolation should block the script. If not, don't push [OK] to
# the next dialog box before the robot has reached the 1/2seating
if(with_trace):
      vs.sendMsg(":script tr.trace")
vs.sendMsg(":waitForFinished")

# -------------------------------------------------------------------------
#waitInputConfirm("Wait before vs stop.")
vs.stop()

# -------------------------------------------------------------------------
#waitInputConfirm("Wait before vs unload.")
vs.sendMsg(':profile')
ms.sendMsg(":destroy vs")
ms.sendMsg(":unload StackOfTasks")

# --- 
# --- LOGS
# --- 
waitInputConfirm("Wait before log")
log.stop()
log.save("steppingForce")

print("Script finished")


