/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Copyright Projet JRL-Japan, 2007
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*
* File:      TestSoTMainProgram.h
* Project:   SOT
* Author:    Keith Franois
*
* Version control
* ===============
*
*  $Id$
*
* Description
* ============
*
*
* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/


#ifndef __TEST_STACK_OF_TASKS_AMELIF_PLUGIN_H__
#define __TEST_STACK_OF_TASKS_AMELIF_PLUGIN_H__

/* -------------------------------------------------------------------------- */
/* --- INCLUDE -------------------------------------------------------------- */
/* -------------------------------------------------------------------------- */

#include <AFApplication/MainProgram.hh>

namespace AFScene
{
	class Universe;
	class MultiBody;
	class SceneLoader;
}

namespace AFSoT
{
	class SoTWrapper;
	class SoTMultiBody;
}

/* -------------------------------------------------------------------------- */
/* --- CLASS ---------------------------------------------------------------- */
/* -------------------------------------------------------------------------- */
class TestSotMainProgram : public AFApplication::MainProgram
{
public:
	TestSotMainProgram( void );
	~TestSotMainProgram( void );

public:
	virtual void initUniverse();
	virtual void initProgram();
	virtual int run(double dt);
	virtual void quitProgram();
	virtual std::string getName();

private:
	AFScene::SceneLoader* _sceneLoader;
	AFScene::Universe* _universe;
	AFSoT::SoTWrapper * _SoT;

	//
	AFScene::MultiBody* _hrp2;
	AFSoT::SoTMultiBody* _SoTHRP2;

	/*! True if run(dt) uses a fixed dt (and not the one provided by AMELIF. */
	bool _fixedTimestep; 	
	double _DefaultTimeStep;
};

#endif
