#include "Tools.hh"

InteractionDisplayer::InteractionDisplayer(AFScene::Universe & univ):
_universe(univ)
{
	_interactionVFVector.resize(200);

	for (unsigned i = 0; i < (int) _interactionVFVector.size() ; ++i)
		_interactionVFVector[i] = new AFScene::DefaultPointInteractionFixture (univ, 10000 + i,NULL);
}

InteractionDisplayer::~InteractionDisplayer ()
{
}

void InteractionDisplayer::newStep ()
{
	//reset the number of interactions
	_interactionNumber = 0;
}

void InteractionDisplayer::runDisplay ()
{
	//display the interaction
	for (int i = 0; i < _interactionNumber; ++i)
		_interactionVFVector[i]->setDisplay(true);

	//cancel the display for the other interaction
	for (int i = _interactionNumber; i < (int) (_interactionVFVector.size()); ++i)
		_interactionVFVector[i]->setDisplay(false);
}

void InteractionDisplayer::processInteraction(AFDynamics::Interaction* c) 
{
}

void InteractionDisplayer::processPointInteraction(AFDynamics::PointInteraction* c) 
{
	//check if the vector is too small, enlarge it if required
	int vecSize = (int) (_interactionVFVector.size());
	if ( vecSize <= _interactionNumber + 1) 
	{
		_interactionVFVector.resize (vecSize + 50);
		for (int i = vecSize; i < vecSize + 50; ++i)
			_interactionVFVector[i] = new AFScene::DefaultPointInteractionFixture (_universe, 10000 + i,NULL);
	}

	//Register the current interaction
	_interactionVFVector[ _interactionNumber ]->reset(c);
	++_interactionNumber;
}

void InteractionDisplayer::processEDInteraction(AFDynamics::EDInteraction* interaction)
{
}



