////////////////////////////////////////////////////////////////////////////////////
// This file describes an interaction displayer
//	and the use of an interaction listener
//
// Franois KEITH, CNRS, 02/2009
////////////////////////////////////////////////////////////////////////////////////

#ifndef INTERACTION_DISPLAYER_HH
#define INTERACTION_DISPLAYER_HH

#include "AFDynamics/PointInteraction.hh"
#include "AFDynamics/InteractionListener.hh"

#include "AFScene/DefaultPointInteractionFixture.hh"

#include <vector>

class InteractionDisplayer : public AFDynamics::InteractionListener
{
public :
	InteractionDisplayer(AFScene::Universe & univ);
	virtual ~ InteractionDisplayer ();

public :
	//re-initialize
	void newStep ();

	//refresh display
	void runDisplay ();

	//how do we handle the different types of interaction
	void processInteraction(AFDynamics::Interaction* c);
	void processPointInteraction(AFDynamics::PointInteraction* c);
	void processEDInteraction(AFDynamics::EDInteraction* interaction);

	//Number of interaction
	int _interactionNumber;

private:
	AFScene::Universe & _universe;
	std::vector<AFScene::DefaultPointInteractionFixture*> _interactionVFVector;
};


#endif /* INTERACTION_LISTENER_HH */
