/*
 * =====================================================================================
 *
 *       Filename:  abstractController.hh
 *
 *    Description:  An abstract controller
 *
 *        Version:  1.0
 *        Created:  04/01/2009 01:15:48 PM
 *       Revision:  none
 *       Compiler:  gcc
 *
 *         Author:  Hak Sovannara (), shak@laas.fr
 *        Company:  
 *
 * =====================================================================================
 */

#ifndef __ABSTRACT_CONTROLLER_HH
#define __ABSTRACT_CONTROLLER_HH

#include <VNL/vector.h>

class abstractController
{
	public:
		abstractController(){}
		virtual ~abstractController(){}

	public:
		virtual VNL::Vector<double> computeTorque() = 0;

	private:
		VNL::Vector<double> _tau;
};

#endif //#ifndef __ABSTRACT_CONTROLLER_HH

