////////////////////////////////////////////////////////////////////////////////////
// stack of tasks and dynamic in AMELIF. 
////////////////////////////////////////////////////////////////////////////////////

#ifndef SADMAINPROGRAMDYNAMIC_HRP2_HH
#define SADMAINPROGRAMDYNAMIC_HRP2_HH

namespace sadMainProgram {
  
  template< class sadMPDynMother >
  class sadMainProgramDynamicHrp2 : public sadMPDynMother
  {
  public:
    
    /* constructor and destructor */
    sadMainProgramDynamicHrp2(){}
    virtual ~sadMainProgramDynamicHrp2(){}
    
  public:
    
    /* get name of the program */
    virtual std::string getName()
    { return sadMPDynMother::getName()+ std::string("HRP2");  }

  protected: 
    using sadMPDynMother::_mainMultiBody;
    
    static const double _FOOT_HEIGHT;


  protected: /* Construction of the scene and modules. */

    virtual void initMultiBodiesConfiguration( void );
  };

  /* --- TEMPLATE FUNCTIONS --- */
  template< class sadMPDynMother >
  void sadMainProgramDynamicHrp2<sadMPDynMother>::
  initMultiBodiesConfiguration( void )
  {
    sadMainProgramDynamicAbstract::initMultiBodiesConfiguration();
    
    /* Computation of the position of the waist for the hrp2
     * when in half sitting. */
    /* First get the chest. */
    AFScene::Body * waist = _mainMultiBody->getBody(0);
    vector3d waistPos; 
    _mainMultiBody->computeDGM();

    AFScene::Body * lleg = _mainMultiBody->getBody(6);
    vector3d llegTrans;
    llegTrans = lleg->getAbsolutePosition();
    waistPos = waist->getAbsolutePosition();
 
    waistPos[2] -= llegTrans[2]-_FOOT_HEIGHT;
    waist->setAbsolutePosition(waistPos );
    _mainMultiBody->computeDGM();
   }

  
  template< class sadMPDynMother >
  const double sadMainProgramDynamicHrp2<sadMPDynMother>::
  _FOOT_HEIGHT = 0.1055;

};


#endif

