////////////////////////////////////////////////////////////////////////////////////
// stack of tasks and dynamic in AMELIF. 
////////////////////////////////////////////////////////////////////////////////////

#ifndef SADMAINPROGRAMDYNAMICTORQUECONTROL_HH
#define SADMAINPROGRAMDYNAMICTORQUECONTROL_HH

#include "sadMainProgramDynamicAbstract.hh"

#include "AFCollision/CollisionDetection.hh"
#include "AFCollision/CollisionPublisher.hh"
#include "AFCollision/DefaultPointCollision.hh"

#include "AFDynamics/InteractionListener.hh"
#include "AFDynamics/DefaultDynamicsSimulatorLoader.hh"
#include "AFDynamics/DynamicsSimulator.hh"

#include "AFUtils/Timer.hh" 

#include "sadTorqueController.hh"


//HRP-2 standing the object
namespace sadMainProgram {
  class sadMainProgramDynamicTorqueControl : public sadMainProgramDynamicAbstract
  {
  public:
    
    /* constructor and destructor */
    sadMainProgramDynamicTorqueControl();
    virtual ~sadMainProgramDynamicTorqueControl();
    
  public:
    
    /* get name of the program */
    virtual std::string getName();

  protected: 
    using sadMainProgramDynamicAbstract::_verbose;
    using sadMainProgramDynamicAbstract::_timeStep;
    using sadMainProgramDynamicAbstract::_mainMultiBody;
    using sadMainProgramDynamicAbstract::_sotMainMultiBody;
    using sadMainProgramDynamicAbstract::_controller;

    const std::string getTorqueControllerConfigXmlMarkup( void ) const;
 
    sadTorqueController* _torqueController;

  private:
    static const std::string _TORQUE_CONTROLLER_CONFIG_XML_MARKUP;

  protected: /* Construction of the scene and modules. */
    virtual void constructController(void);
    virtual void initController( void );

    virtual void initTimeFactor( void );
	  
  };
};

#endif

