////////////////////////////////////////////////////////////////////////////////////
// stack of tasks and dynamic in AMELIF. 
////////////////////////////////////////////////////////////////////////////////////

#ifndef SADMAINPROGRAMDYNAMICVELOCITYCONTROL_HH
#define SADMAINPROGRAMDYNAMICVELOCITYCONTROL_HH

#include "sadMainProgramDynamicAbstract.hh"
#include "sadPDController.hh"

namespace sadMainProgram {
  class sadMainProgramDynamicVelocityControl : public sadMainProgramDynamicAbstract
  {
  public:
    
    /* constructor and destructor */
    sadMainProgramDynamicVelocityControl();
    virtual ~sadMainProgramDynamicVelocityControl();
    
  public:
    
    /* get name of the program */
    virtual std::string getName();

  protected: 
    using sadMainProgramDynamicAbstract::_verbose;
    using sadMainProgramDynamicAbstract::_timeStep;
    using sadMainProgramDynamicAbstract::_mainMultiBody;
    using sadMainProgramDynamicAbstract::_sotMainMultiBody;
    using sadMainProgramDynamicAbstract::_controller;
    virtual const std::string getControllerConfigXmlMarkup( void ) const;

    sadPDController* _pdcontroller;

  private:
    static const std::string _CONTROLLER_CONFIG_XML_MARKUP;


  protected: /* Construction of the scene and modules. */
    virtual void constructController(void);
    virtual void initController( void );

    virtual void initTimeFactor( void );
	  
  };
};

#endif

