#include "sadMainProgramKinematics.hh"

namespace sadMainProgram {
  
  sadMainProgramKinematics::sadMainProgramKinematics()
    :sadMainProgramAbstract()
  {
  }
  
  sadMainProgramKinematics::~sadMainProgramKinematics()
  {
  }

  const double  sadMainProgramKinematics::_DEFAULT_TIME_STEP = 5e-3;
  const double sadMainProgramKinematics::getDefaultTimeStep( void ) const
  { return sadMainProgramKinematics::_DEFAULT_TIME_STEP; }


  void sadMainProgramKinematics::
  runController( const double& timeStep )
  {
    int numParam = _mainMultiBody->getNumParameters();
    VNL::Vector<double> mbState (numParam);
    VNL::Vector<double> mbVelocity (numParam);
    
    _mainMultiBody->getStateVector( mbState );
    _sotMainMultiBody->getControlLaw(mbVelocity);
    
    mbVelocity *= timeStep;
    mbState+=mbVelocity;
    _mainMultiBody->setStateVector(mbState);
  }
  
  std::string sadMainProgramKinematics::getName()
  { return "AfSotKinematics"; }
}


