////////////////////////////////////////////////////////////////////////////////////
// stack of tasks and kinematics in AMELIF. 
////////////////////////////////////////////////////////////////////////////////////

#ifndef SAD_MP_KINEMATICS_HH
#define SAD_MP_KINEMATICS_HH

#include "sadMainProgramAbstract.hh"

namespace sadMainProgram {
  class sadMainProgramKinematics : public sadMainProgramAbstract 
  {
  public:
    
    /* constructor and destructor */
    sadMainProgramKinematics();
    virtual ~sadMainProgramKinematics();
    
  public:
    /* get name of the program */
    virtual std::string getName();
    
  private: /* Main-program generic paramaters. */
    static const double  _DEFAULT_TIME_STEP;

  protected:  /* Access to the main-program generic paramaters. */
    virtual const double getDefaultTimeStep( void ) const;

  protected: /* Initialization of the scene and modules. */
    virtual void constructController( void ) {}
    virtual void initSimulation( void ) {}
    virtual void initController( void ) {}
    virtual void runSimulation( const double& timeStep ) {}
    virtual void destructSimulation( void ) {}
    virtual void destructController( void ) {}

  protected: /* Main-program inheritance. */
    virtual void runController( const double& timeStep );
  };
};

#endif

