/* --- INCLUDES -------------------------------------------------------------- */
/* --- INCLUDES -------------------------------------------------------------- */
/* --- INCLUDES -------------------------------------------------------------- */
#include <ctime>
#include <fstream>
#include "connection.h"
#include "sotDebug.h"

#include "ConnectionToCorba.h"
using namespace sfbcomm;

/* --- IP AND CONFIG --------------------------------------------------------- */
/* --- IP AND CONFIG --------------------------------------------------------- */
/* --- IP AND CONFIG --------------------------------------------------------- */
#define IPADDR "129.187.147.174"      // IP adress of the remote computer TUM
//#define IPADDR "172.16.59.1"        // IP adress of Vision server
//#define IPADDR "150.29.191.252"     // IP adress of Sylvain's comp.
//#define IPADDR "150.29.190.242"     // IP adress of jrlhrp01
#define RECVPORT 4444                 // receive port
#define SENDPORT 4445                 // send port
     

/* --- GLOBAL VARIABLES ------------------------------------------------------ */
/* --- GLOBAL VARIABLES ------------------------------------------------------ */
/* --- GLOBAL VARIABLES ------------------------------------------------------ */
connection* recvConn;      // UDP connection for receiving data from realtime prozess
connection* sendConn;      // UDP connection for sending data to realtime prozess

ConnectionToCorba* aConnectionToCorba;

extern TeleopWithTUM_Server::SeqMeasureData Measures_from_HRP_Threads_Exchange;  
extern TeleopWithTUM_Server::ControlData Control_to_HRP_Threads_Exchange;

pthread_mutex_t UDP_CORBA_Exchange_Mutex;

ofstream data_send_TUM;
ofstream data_recv_TUM;

/* --- RECEIVE --------------------------------------------------------------- */
/* --- RECEIVE --------------------------------------------------------------- */
/* --- RECEIVE --------------------------------------------------------------- */
void 
recvData(void)
{
  sotDEBUGIN(15);
  sotDEBUG(25) << "Entering recvData !" << endl;

  int             err;
  const int       NB_DATA = 14; // 14
  double          x[NB_DATA];   // Temp variable.
  double          latency = 0;  // Used to measure the latency.
  bool            setToNone = false;
  timeval         last_recv_time;
  timeval         curr_time;
  unsigned long   diff_time_micros;

  gettimeofday(&last_recv_time, NULL);
  gettimeofday(&curr_time, NULL);

  /* Create the data structure. */
  datatype *recv_data = new datatype();
  recv_data->createbuffer("A", (long) sizeof(x));
  recv_data->setbuffer("A", (unsigned char *)x);

  recv_data->createbuffer("latency", (long) sizeof(double));
  recv_data->setbuffer("latency", (unsigned char *)&latency);
    
  for(int i=0; i< NB_DATA; i++)   { x[i]=0.0; }

  /* Receive data from the network. */
  while (true) 
    {
      /* Read the data. */
      err = recvConn->receivedata(recv_data,1);
      gettimeofday(&curr_time, NULL);

      if( err < 0 ) /* If we did not get a measure.... */
	{
	  diff_time_micros = (unsigned long)(curr_time.tv_sec 
					     - last_recv_time.tv_sec) 
	    * 1000000L 
	    + (unsigned long)(curr_time.tv_usec - last_recv_time.tv_usec);
            
	  if (diff_time_micros > 200000L)
            {
	      if( setToNone==false)
		{
	          Control_to_HRP_Threads_Exchange.controlScheme 
		    = TeleopWithTUM_Server::NONE;
		  aConnectionToCorba->SetControlData();
                  setToNone = true;
		}
            }
	} 
      else 
	{ /* else we get a measure ... */
	  setToNone = false;	      
	  
	  last_recv_time = curr_time;
	  
	  /* Get desired cartesian position of the head. */
	  Control_to_HRP_Threads_Exchange.Head.px = 0.0; //x[i];
	  Control_to_HRP_Threads_Exchange.Head.py = 0.0; //x[i];
	  Control_to_HRP_Threads_Exchange.Head.pz = 0.0; //x[i];
	  
	  /* Get desired Yaw and Pitch of the head. */
	  Control_to_HRP_Threads_Exchange.Head.yaw = x[10];
	  Control_to_HRP_Threads_Exchange.Head.pitch = x[11];
	  
	  /* Get command force. */
	  for(int i = 0;i < 3; ++i)
	    {
	      Control_to_HRP_Threads_Exchange.Rarm[i] = x[i];
	      Control_to_HRP_Threads_Exchange.Larm[i] = 0.0; //x[i];
	    }
	  /* Get command torque. */
	  for(int i = 3; i < 6; ++i)
            {
	      Control_to_HRP_Threads_Exchange.Rarm[i] = x[i];
            }
	  /* Get gripper distance. */
	  Control_to_HRP_Threads_Exchange.Rarm[7] = x[9];
	  
	  /* Get position. */
	  Control_to_HRP_Threads_Exchange.Rarm[8] = x[6];
	  Control_to_HRP_Threads_Exchange.Rarm[9] = x[7];
	  Control_to_HRP_Threads_Exchange.Rarm[10] = x[8];
	  
	  /* Get left arm torque and gripper distance. */
	  for(int i = 3; i < 7; ++i)
            {
	      Control_to_HRP_Threads_Exchange.Larm[i] = 0.0;
            }
      
	  /* Get package number. */
	  Control_to_HRP_Threads_Exchange.Package_Number 
	    = (unsigned long) x[13];
	  if( x[12]==1.0 ) 
	    { Control_to_HRP_Threads_Exchange.controlScheme 
		= TeleopWithTUM_Server::F_V; }
	  else
	    { Control_to_HRP_Threads_Exchange.controlScheme 
		= TeleopWithTUM_Server::NONE; }
      
	  /* !!!!!!!!!!! Removed for open loop test with TUM !!!!!!!!!!!! */
	  aConnectionToCorba->SetControlData();

	  ////////////// Debug: display received data ////////////
	  // display received data
	  //cerr << "Received data: ";
	  // control scheme, package number, and head orientation
	  //cerr << x[12] << " " << x[13] << " " << x[10] << " " << x[11] << endl; 
	  data_recv_TUM << curr_time.tv_sec << " " << curr_time.tv_usec << " " ;
	  for(int i=0;i<NB_DATA;i++) { data_recv_TUM << x[i] << " " ; }
	  data_recv_TUM << endl;
	  ////////////////////////////////////////////////////////
	}
    }
  sotDEBUGOUT(15);
}

/* --- SEND ------------------------------------------------------------------ */
/* --- SEND ------------------------------------------------------------------ */
/* --- SEND ------------------------------------------------------------------ */
void sendData(void)
{
  sotDEBUGOUT(15);
  sotDEBUG(25) << "Entering sendData !" << endl;

  /* Local variables. */
  int                  err = 0;
  datatype *           send_data = new datatype();
  static unsigned long packn = 0ul;
  const int            NB_DATA = 8;  
  double               x[NB_DATA];   // Temp variable
  double               latency;      // Used to measure the latency
  timeval              last_recv_time;
  timeval              curr_time;
  //unsigned long        diff_time_micros;
  unsigned long        waitTime;

  /* Init time counters. */
  gettimeofday(&last_recv_time, NULL);
  gettimeofday(&curr_time, NULL);

  /* Create the data structure. */
  send_data->createbuffer("B", (long) sizeof(x));
  send_data->setbuffer("B",(unsigned char *)x);
  send_data->createbuffer("latency", (long) sizeof(double));
  send_data->setbuffer("latency", (unsigned char *) &latency);

  while(true)
    {
      gettimeofday(&curr_time, NULL);
      //waitTime = 20000L - 
      // ( (unsigned long)(curr_time.tv_sec - last_recv_time.tv_sec) 
      // * 1000000L 
      // + (unsigned long)(curr_time.tv_usec - last_recv_time.tv_usec) );
      waitTime = 18000L;  // Seems to be the best value to get 20ms period
      if(waitTime > 0)
	{ usleep(waitTime); }
      gettimeofday(&last_recv_time, NULL);
      sotDEBUG(45) << curr_time.tv_usec << endl;

      aConnectionToCorba->GetMeasureData();

      /* Try to read measure data. As soon as there is some, copy it into
       * buffers that will be sent to TUM. */
      if( Measures_from_HRP_Threads_Exchange.length()>0 )
	{
	  TeleopWithTUM_Server::MeasureData& Measure_from_HRP =
	    Measures_from_HRP_Threads_Exchange
	    [Measures_from_HRP_Threads_Exchange.length()-1];
	  
	  /* Send positions and quaternion of the hand. */
	  for(int i = 0; i < 7; ++i) //put 7 to send the quaternion
	    x[i] = Measure_from_HRP.Rarm[i];
	  x[7] = (double) (++packn);
	}
      else
	continue; // --- sorry for that
      
      // clear sequence
      int l = Measures_from_HRP_Threads_Exchange.length();
      Measures_from_HRP_Threads_Exchange.length(0);
      Measures_from_HRP_Threads_Exchange.length(l);
      
      ////////////// Debug: display received data ////////////
      // display received data
      sotDEBUG(25) << "Sent data: " << std::endl;
      for(int i=0;i<3;i++)  sotDEBUG(25) << x[i] << " " << std::endl;
      sotDEBUG(25) << latency << endl;
      //data_send_TUM << curr_time.tv_sec << " " << curr_time.tv_usec << " " ;
      //for(int i=0;i<NB_DATA;i++)
      //data_send_TUM << x[i] << " " ;
      //data_send_TUM << endl;
      ////////////////////////////////////////////////////////  

      /* Should we keep this ? */
      //do { err = sendConn->senddata(send_data,1); }
      //while (err < 0);
      err = sendConn->senddata(send_data,1);

      
    }
  sotDEBUGOUT(15);
}

/* --- CONTROL --------------------------------------------------------------- */
/* --- CONTROL --------------------------------------------------------------- */
/* --- CONTROL --------------------------------------------------------------- */
void *
controlThread( void* dummy )
{
  sotDEBUGIN(15);
  /* Setup a udp connection to receive from the network. */
  recvConn = new connection(RECVPORT, IPADDR, RECVPORT,1);

  sotDEBUG(1) << "Did I start the control thread ? "<<endl;
  // check to ensure that the udp connection was setup correctly
  switch (recvConn->geterror()) 
    {
    case HOST_NOT_FOUND: 
      {
	cerr << "Please enter a correct hostname or IP-Address!" 
	     << endl;
	exit(-1);
      }
    case SOCK_FAILED: 
      {
	cerr << "Could not create Socket!" << endl; 
	exit(-1);
      }
    case BIND_FAILED: 
      {
	cerr << "Could not bind Port!" << endl;
	exit(-1);
      }
    default:             
      break; 
    }
  
  /* Start receiving control data. */
  recvData();
  
  /* Exit the thread. */
  sotDEBUGOUT(15);
  pthread_exit(NULL);
}

/* --- MEASURE --------------------------------------------------------------- */
/* --- MEASURE --------------------------------------------------------------- */
/* --- MEASURE --------------------------------------------------------------- */
void *
measureThread(void*)
{
  sotDEBUGIN(15);
  /* Create a udp connection to send data over the network. */
  sendConn = new connection(SENDPORT, IPADDR, SENDPORT,1);
 
  /* Check to ensure that the udp connection was setup correctly. */
  switch( sendConn->geterror() )
    {
    case HOST_NOT_FOUND: 
      {
	cerr << "Please enter a correct hostname or IP-Address!" << endl;
	sotDEBUGOUT(1);
	exit(-1);
      }
    case SOCK_FAILED: 
      {
	cerr << "Could not create Socket!" << endl; 
	sotDEBUGOUT(1);
	exit(-1);
      }
    case BIND_FAILED:
      cerr << "Could not bind Port!" << endl; 
      sotDEBUGOUT(1);
      exit(-1);
    default:             
      break; 
    }

  sotDEBUG(15) << "Did the check succeded ? "<<endl;

  /* Start communication. */
  sendData();

  /* Exit the thread. */
  sotDEBUGOUT(15);
  pthread_exit(NULL);
}

/* --- MAIN ------------------------------------------------------------------ */
/* --- MAIN ------------------------------------------------------------------ */
/* --- MAIN ------------------------------------------------------------------ */

int 
main( int argc, char **argv )
{
  sotDEBUGIN(1);
  data_send_TUM.open("Data_send_TUM.sav");
  data_recv_TUM.open("Data_recv_TUM.sav");

  string arguments("tele  ");
  istringstream istrm(arguments);

  sotDEBUG(10) << "Connection to corba... "<<std::endl;
  aConnectionToCorba = new ConnectionToCorba(istrm);
  sotDEBUG(10) << "Connection to corba... done!"<<std::endl;

  /* init the mutex for exchange of measure data between 
   * CORBA structures and buffers for UDP. */
  pthread_mutex_init(&UDP_CORBA_Exchange_Mutex, NULL);

  /* --- Receive thread --- */
  pthread_t controlThreadHandle; // local variable
  pthread_create(&controlThreadHandle, NULL, controlThread, NULL); // start the thread
  pthread_t measureThreadHandle; // local variable
  pthread_create(&measureThreadHandle, NULL, measureThread, NULL); // start the thread

  pthread_join(controlThreadHandle,0);
  pthread_join(measureThreadHandle,0);

  data_send_TUM.close();
  data_recv_TUM.close();

  sotDEBUGOUT(1);
  return 0;
}

