#ifndef _EXCHANGE_DATA_TYPES_H_
#define _EXCHANGE_DATA_TYPES_H_

#include <vector>

namespace EDT
{
  typedef struct
  {
    float p[3];
    float yaw;
    float pitch;
  } TransformYawPitch;
  typedef struct
  {
    float p[3];
    float q[4];
  } TransformQuaternion;
  
  typedef struct
  {
    TransformYawPitch Head;
    TransformQuaternion RightGripper;
    TransformQuaternion LeftGripper;
  } EndEffectorsTorso;
  
  typedef struct 
  {
    EndEffectorsTorso EndEffectors;
    float GripperForces[2][6];
  } TelepresenceData;

  extern std::vector<TelepresenceData> BufferOfRobotInfos;
  extern EndEffectorsTorso HeadRLGrippers;
};
#endif /* _EXCHANGE_DATA_TYPES_H_ */
