/* --- INCLUDES -------------------------------------------------------------- */
/* --- INCLUDES -------------------------------------------------------------- */
/* --- INCLUDES -------------------------------------------------------------- */
#include <ctime>
#include <fstream>
#include "connection.h"
#include "sotDebug.h"

using namespace sfbcomm;

/* --- IP AND CONFIG --------------------------------------------------------- */
/* --- IP AND CONFIG --------------------------------------------------------- */
/* --- IP AND CONFIG --------------------------------------------------------- */
#define IPADDR "129.187.147.174"      // IP adress of the remote computer TUM
//#define IPADDR "172.16.59.1"        // IP adress of Vision server
//#define IPADDR "150.29.191.252"     // IP adress of Sylvain's comp.
//#define IPADDR "150.29.190.242"     // IP adress of jrlhrp01
//#define IPADDR "150.29.191.84"        // TELEJP

#define RECVPORT 4446                 // receive port

#define SENDPORT 4445                 // send port
     

/* --- GLOBAL VARIABLES ------------------------------------------------------ */
/* --- GLOBAL VARIABLES ------------------------------------------------------ */
/* --- GLOBAL VARIABLES ------------------------------------------------------ */

connection* recvConn;      // UDP connection for receiving data from realtime prozess
connection* sendConn;      // UDP connection for sending data to realtime prozess

ofstream data_send_TUM;
ofstream data_recv_TUM;

/* --- RECEIVE --------------------------------------------------------------- */
/* --- RECEIVE --------------------------------------------------------------- */
/* --- RECEIVE --------------------------------------------------------------- */
void 
recvData(void)
{
  sotDEBUGIN(15);

  int             err;
  const int       NB_DATA = 10; // 14
  double          x[NB_DATA];   // Temp variable.
  double          latency = 0;  // Used to measure the latency.
  bool            setToNone = false;
  timeval         last_recv_time;
  timeval         curr_time;
  unsigned long   diff_time_micros;

  gettimeofday(&last_recv_time, NULL);
  gettimeofday(&curr_time, NULL);

  /* Create the data structure. */
  sotDEBUG(15) << "Init the data. " << std::endl;
  datatype *recv_data = new datatype();
  recv_data->createbuffer("A", (long) sizeof(x));
  recv_data->setbuffer("A", (unsigned char *)x);

  recv_data->createbuffer("latency", (long) sizeof(double));
  recv_data->setbuffer("latency", (unsigned char *)&latency);
    
  for(int i=0; i< NB_DATA; i++)   { x[i]=-10.0; }

  /* Receive data from the network. */
  sotDEBUG(15) << "Start the recv loop. " << std::endl;
  while (true) 
    {
      /* Read the data. */
      sotDEBUG(15) << "connect ... " << std::endl;
      err = recvConn->receivedata(recv_data,1);
      gettimeofday(&curr_time, NULL);
      sotDEBUG(15) << "connect done!" << std::endl;

      if( err < 0 ) /* If we did not get a measure.... */
	{
	  diff_time_micros 
	    = ((unsigned long)(curr_time.tv_sec-last_recv_time.tv_sec) 
	       * 1000000L 
	       +(unsigned long)(curr_time.tv_usec - last_recv_time.tv_usec));
            
	  if (diff_time_micros > 200000L)
            {
	      if(! setToNone ) { cerr << " Error while recv. " << endl; }
            }
	} 
      else 
	{ /* else we get a measure ... */
	  setToNone = false;	      
	  
	  last_recv_time = curr_time;
	  

	  ////////////// Debug: display received data ////////////
	  // display received data
	  //cerr << "Received data: ";
	  // control scheme, package number, and head orientation
	  //cerr << x[12] << " " << x[13] << " " << x[10] << " " << x[11] << endl; 
	  data_recv_TUM << curr_time.tv_sec << " " << curr_time.tv_usec << " " ;
	  for(int i=0;i<NB_DATA;i++) { data_recv_TUM << "<" << i << "> "<<x[i] << " " ; }
	  data_recv_TUM << endl;
	  ////////////////////////////////////////////////////////
	}
    }
  sotDEBUGOUT(15);
}


/* --- CONTROL --------------------------------------------------------------- */
/* --- CONTROL --------------------------------------------------------------- */
/* --- CONTROL --------------------------------------------------------------- */
void *
controlThread( void* dummy )
{
  sotDEBUGIN(15);
  /* Setup a udp connection to receive from the network. */
  sotDEBUG(15) << "Connect to " << IPADDR
	       << " on port " << RECVPORT << std::endl;
  recvConn = new connection(RECVPORT, (char*)IPADDR, RECVPORT,1);

  sotDEBUG(1) << "Did I start the control thread ? "<<recvConn->geterror()<<endl;
  // check to ensure that the udp connection was setup correctly
  switch (recvConn->geterror()) 
    {
    case HOST_NOT_FOUND: 
      {
	cerr << "Please enter a correct hostname or IP-Address!" 
	     << endl;
	exit(-1);
      }
    case SOCK_FAILED: 
      {
	cerr << "Could not create Socket!" << endl; 
	exit(-1);
      }
    case BIND_FAILED: 
      {
	cerr << "Could not bind Port!" << endl;
	exit(-1);
      }
    case CONNECT_FAILED: 
      {
	cerr << "Could not connect!" << endl;
	exit(-1);
      }
    default:             
      break; 
    }
  
  /* Start receiving control data. */
  recvData();
  
  /* Exit the thread. */
  sotDEBUGOUT(15);
  //pthread_exit(NULL);
  return NULL;
}


/* --- MAIN ------------------------------------------------------------------ */
/* --- MAIN ------------------------------------------------------------------ */
/* --- MAIN ------------------------------------------------------------------ */

int 
main( int argc, char **argv )
{
  sotDebugTrace::openFile();

  sotDEBUGIN(1);
  data_send_TUM.open("/tmp/nmansard/Data_send_TUM.sav");
  data_recv_TUM.open("/tmp/nmansard/Data_recv_TUM.sav");

  /* --- Receive thread --- */
  sotDEBUG(1) << "control ... " << std::endl;
  controlThread(NULL); 

  data_send_TUM.close();
  data_recv_TUM.close();

  sotDEBUGOUT(1);
  return 0;
}

