/* --- INCLUDES -------------------------------------------------------------- */
/* --- INCLUDES -------------------------------------------------------------- */
/* --- INCLUDES -------------------------------------------------------------- */
#include <ctime>
#include <fstream>
#include "connection.h"
#include "sotDebug.h"

using namespace sfbcomm;

/* --- IP AND CONFIG --------------------------------------------------------- */
/* --- IP AND CONFIG --------------------------------------------------------- */
/* --- IP AND CONFIG --------------------------------------------------------- */
#define IPADDR "129.187.147.174"      // IP adress of the remote computer TUM
//#define IPADDR "172.16.59.1"        // IP adress of Vision server
//#define IPADDR "150.29.191.252"     // IP adress of Sylvain's comp.
//#define IPADDR "150.29.190.242"     // IP adress of jrlhrp01
#define RECVPORT 4446                 // receive port
#define SENDPORT 4445                 // send port
     

/* --- GLOBAL VARIABLES ------------------------------------------------------ */
/* --- GLOBAL VARIABLES ------------------------------------------------------ */
/* --- GLOBAL VARIABLES ------------------------------------------------------ */

connection* recvConn;      // UDP connection for receiving data from realtime prozess
connection* sendConn;      // UDP connection for sending data to realtime prozess

ofstream data_send_TUM;
ofstream data_recv_TUM;

/* --- SEND ------------------------------------------------------------------ */
/* --- SEND ------------------------------------------------------------------ */
/* --- SEND ------------------------------------------------------------------ */
void 
sendData(void)
{
  sotDEBUGOUT(15);
  sotDEBUG(25) << "Entering sendData !" << endl;

  /* Local variables. */
  int                  err = 0;
  datatype *           send_data = new datatype();
  static unsigned long packn = 0ul;
  const int            NB_DATA = 8;  
  double               x[NB_DATA];   // Temp variable
  double               latency;      // Used to measure the latency
  timeval              last_recv_time;
  timeval              curr_time;
  //unsigned long        diff_time_micros;
  unsigned long        waitTime;

  /* Init time counters. */
  gettimeofday(&last_recv_time, NULL);
  gettimeofday(&curr_time, NULL);

  /* Create the data structure. */
  send_data->createbuffer("B", (long) sizeof(x));
  send_data->setbuffer("B",(unsigned char *)x);
  send_data->createbuffer("latency", (long) sizeof(double));
  send_data->setbuffer("latency", (unsigned char *) &latency);

  while(true)
    {
      gettimeofday(&curr_time, NULL);
      //waitTime = 20000L - 
      // ( (unsigned long)(curr_time.tv_sec - last_recv_time.tv_sec) 
      // * 1000000L 
      // + (unsigned long)(curr_time.tv_usec - last_recv_time.tv_usec) );
      waitTime = 18000L;  // Seems to be the best value to get 20ms period
      if(waitTime > 0)
	{ usleep(waitTime); }
      gettimeofday(&last_recv_time, NULL);
      sotDEBUG(45) << curr_time.tv_usec << endl;

      /* Send positions and quaternion of the hand. */
      for(int i = 0; i < 7; ++i) //put 7 to send the quaternion
	x[i] = i;
      x[7] = (double) (++packn);
   
      ////////////// Debug: display received data ////////////
      // display received data
      sotDEBUG(25) << "Sent data: " << std::endl;
      for(int i=0;i<3;i++)  sotDEBUG(25) << x[i] << " " << std::endl;
      sotDEBUG(25) << latency << endl;
      //data_send_TUM << curr_time.tv_sec << " " << curr_time.tv_usec << " " ;
      //for(int i=0;i<NB_DATA;i++)
      //data_send_TUM << x[i] << " " ;
      //data_send_TUM << endl;
      ////////////////////////////////////////////////////////  

      /* Should we keep this ? */
      //do { err = sendConn->senddata(send_data,1); }
      //while (err < 0);
      err = sendConn->senddata(send_data,1);

      
    }
  sotDEBUGOUT(15);
}

/* --- MEASURE --------------------------------------------------------------- */
/* --- MEASURE --------------------------------------------------------------- */
/* --- MEASURE --------------------------------------------------------------- */
void *
measureThread(void*)
{
  sotDEBUGIN(15);
  /* Create a udp connection to send data over the network. */
  sendConn = new connection(SENDPORT, (char*)IPADDR, SENDPORT,1);
 
  /* Check to ensure that the udp connection was setup correctly. */
  switch( sendConn->geterror() )
    {
    case HOST_NOT_FOUND: 
      {
	cerr << "Please enter a correct hostname or IP-Address!" << endl;
	sotDEBUGOUT(1);
	exit(-1);
      }
    case SOCK_FAILED: 
      {
	cerr << "Could not create Socket!" << endl; 
	sotDEBUGOUT(1);
	exit(-1);
      }
    case BIND_FAILED:
      cerr << "Could not bind Port!" << endl; 
      sotDEBUGOUT(1);
      exit(-1);
    default:             
      break; 
    }

  sotDEBUG(15) << "Did the check succeded ? "<<endl;

  /* Start communication. */
  sendData();

  /* Exit the thread. */
  sotDEBUGOUT(15);
  pthread_exit(NULL);
}

/* --- MAIN ------------------------------------------------------------------ */
/* --- MAIN ------------------------------------------------------------------ */
/* --- MAIN ------------------------------------------------------------------ */

int 
main( int argc, char **argv )
{
  sotDebugTrace::openFile();

  sotDEBUGIN(1);
  data_send_TUM.open("/tmp/nmansard/Data_send_TUM.sav");
  data_recv_TUM.open("/tmp/nmansard/Data_recv_TUM.sav");

  /* --- Send --- */
  sotDEBUG(1) << "control ... " << std::endl;
  measureThread(NULL);
  
  data_send_TUM.close();
  data_recv_TUM.close();

  sotDEBUGOUT(1);
  return 0;
}

