
#include "connection.h"


#define IPADDR "129.187.147.229" // IP adress of the remote computer
#define RECVPORT 1026            // receive port
#define SENDPORT 1025            // send port
     
using namespace sfbcomm;

connection* recvConn;      // UDP connection for receiving data from realtime prozess
connection* sendConn;     // UDP connection for sending data to realtime prozess



void recvData(void)
{
  double xp[3]; //Cartesian position
  double Q[4];  //Quaternion
  double x[7];  //temp variable
  double latency; //this variable is used to measure the latency 
  
  datatype *recv_data = new datatype();

  // create the data structure
  recv_data->createbuffer("A", (long) sizeof(x));
  recv_data->setbuffer("A", (unsigned char *)x);

  recv_data->createbuffer("latency", (long) sizeof(double));
  recv_data->setbuffer("latency", (unsigned char *)&latency);
    
  for(int i=0; i< 7; i++)
    x[i]=0.0;

  
  // receive data from the network
  while (true) 
    {
      do 
	{ 
	  err = recvConn->receivedata(recv_data,1);
	}
      while (err < 0);
      
      // send the data over the network.
      sendData();
      
      // read data
      recvConn->receivedata(recv_data,1);
      
      //example: get Cartesian position
      xp[0] = x[0];
      xp[1] = x[1];
      xp[2] = x[2];
      
      //example: get Quaternion
      Q[0] = x[3];
      Q[1] = x[4];
      Q[1] = x[5];
      Q[3] = x[6];
      
    }
}


void sendData(void)
{
  // local variables
  int err = 0;
  datatype *send_data = new datatype();
  double x[3]; //temp variable
  float f[3]={0.0,0.0,0.0};      //translational force in reference frame coordinate system
  
  // create the data structure
  send_data->createbuffer("B", (long) sizeof(x));
  send_data->setbuffer("B",(unsigned char *)x);

  //initialization to zero in the beginning
  for(int i=0; i< 3; i++)
    x[i]=0.0;
  
  //example: write force
  x[0]=f[0]; 
  x[1]=f[1];
  x[2]=f[2];
  
 	
  do { err = sendConn->senddata(send_data,1);}
  while (err < 0);
  
}




void *commThread(void*)
{
  // setup a udp connection to receive from the network
  recvConn = new connection(RECVPORT, IPADDR, RECVPORT,1);

  // check to ensure that the udp connection was setup correctly
  switch (recvConn->geterror()) {
  case HOST_NOT_FOUND: cerr << "Please enter a correct hostname or IP-Address!" << endl; exit(-1);
  case SOCK_FAILED:    cerr << "Could not create Socket!" << endl; exit(-1);
  case BIND_FAILED:    cerr << "Could not bind Port!" << endl; exit(-1);
  default:             ; }

  // create a udp connection to send data over the network

  sendConn = new connection(SENDPORT, IPADDR, SENDPORT,1);
 
  // check to ensure that the udp connection was setup correctly
  switch (sendConn->geterror()) {
  case HOST_NOT_FOUND: cerr << "Please enter a correct hostname or IP-Address!" << endl; exit(-1);
  case SOCK_FAILED:    cerr << "Could not create Socket!" << endl; exit(-1);
  case BIND_FAILED:    cerr << "Could not bind Port!" << endl; exit(-1);
  default:             ; }

  // start communication
  recvData();

  // exit the thread
  pthread_exit(NULL);
}

/***main***/
int main(int argc, char **argv)
{
   
  // receive thread
  pthread_t startCommThread; // local variable
  pthread_create(&startCommThread, NULL, commThread, NULL); // start the thread
	
}

