/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 * Copyright Projet JRL-Japan, 2007
 *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 *
 * File:      sotNextStep.h
 * Project:   SOT
 * Author:    Nicolas Mansard
 *
 * Version control
 * ===============
 *
 *  $Id$
 *
 * Description
 * ============
 *
 *
 * ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/



#ifndef __SOT_SOTNEXTSTEP_OHRP_H__
#define __SOT_SOTNEXTSTEP_OHRP_H__

/* --------------------------------------------------------------------- */
/* --- INCLUDE --------------------------------------------------------- */
/* --------------------------------------------------------------------- */

/* Matrix */
#include <MatrixAbstractLayer/boost.h>
namespace ml = maal::boost;

/* SOT */
#include <sot/sotNextStep.h>
#include "StackOfTasks.h"  

/* STD */
#include <string>
#include <deque>

/* --------------------------------------------------------------------- */
/* --- API ------------------------------------------------------------- */
/* --------------------------------------------------------------------- */

#if defined (WIN32) 
#  if defined (sotNextStepOpenHRP_EXPORTS) 
#    define SOTNEXTSTEPOPENHRP_EXPORT __declspec(dllexport)
#  else  
#    define SOTNEXTSTEPOPENHRP_EXPORT __declspec(dllimport)
#  endif 
#else
#  define SOTNEXTSTEPOPENHRP_EXPORT
#endif

/* --------------------------------------------------------------------- */
/* --- CLASS ----------------------------------------------------------- */
/* --------------------------------------------------------------------- */


class SOTNEXTSTEPOPENHRP_EXPORT sotNextStepOpenHRP
:public sotNextStep
{
 public:
  static const std::string CLASS_NAME;
  virtual const std::string& getClassName( void ) const { return CLASS_NAME; }

 protected:

  StackOfTasks *sot_ptr;
  
 public: /* --- CONSTRUCTION --- */
  sotNextStepOpenHRP( const std::string& name );
  virtual ~sotNextStepOpenHRP( void ) {} 


 public: /* --- FUNCTIONS --- */

  virtual void starter( const int & timeCurr );
  virtual void stoper( const int & timeCurr );
  virtual void introductionCallBack( const int & timeCurr );


};





#endif // #ifndef __SOT_SOTNEXTSTEP_OHRP_H__

