/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 * Copyright Projet JRL-Japan, 2007
 *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 *
 * File:      sotServerAbstract.h
 * Project:   SOT
 * Author:    Nicolas Mansard
 *
 * Version control
 * ===============
 *
 *  $Id$
 *
 * Description
 * ============
 *
 *
 * ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/


#ifndef __SOT_SERVER_ABSTRACT_HH__
#define __SOT_SERVER_ABSTRACT_HH__

/* --------------------------------------------------------------------- */
/* --- INCLUDE --------------------------------------------------------- */
/* --------------------------------------------------------------------- */

/* SOT */
#include <sot/sotConfig.h>
#include <sot/sotEntity.h>
#include <sot/CORBAReference.h>

#if HAVE_OPENHRP==1
#if HAVE_OPENHRP_V2==1
#include <plugin.h>
#endif // HAVE_OPENHRP_V2
#endif // HAVE_OPENHRP 

class sotServerAbstract
:
#if HAVE_OPENHRP==1
#if HAVE_OPENHRP_V2==1
public plugin, // Implementation of the start/stop functions
#endif // HAVE_OPENHRP_V2
#endif // #ifdef HAVE_OPENHRP
public sotEntity
{
 private:
  CORBAReference m_ORBRef;

 public:

  const CORBAReference & getORBRef() const
    {return m_ORBRef;}
  sotServerAbstract( const std::string& name );
  virtual ~sotServerAbstract ( void ) {}

  void commandLine( const std::string& cmdLine,std::istringstream& cmdArgs,
		    std::ostream& os );
#if HAVE_OPENHRP==1
#if HAVE_OPENHRP_V2==1
  void bindCorbaServer( plugin_manager* OpenHRP_manager );
#endif // HAVE_OPENHRP_V2
#endif // HAVE_OPENHRP 

  void bindCorbaServer( );
  virtual void rebind(CosNaming::Name & corbaCosName);
  virtual void initialBinding();

 public:
};



#else // #ifndef __SOT_SERVER_ABSTRACT_HH__

#ifndef __SOT_SERVER_ABSTRACT_CC__
#  warning Class sotServerAbstract cannot be defined since OpenHRP is absent. 
#endif

class sotServerAbstract
: public sotEntity
{
 private:
  CORBAReference m_ORBRef;
  sotServerAbstract( const std::string& name );

  virtual ~sotServerAbstract ( void ) {}
  void commandLine( const std::string& cmdLine,std::istringstream& cmdArgs,std::ostream& os )
    { os << "sotServerAbstract is not defined." << std::endl; }

  virtual void Rebind(CosNaming::Name & corbaCosName);
  virtual void InitialBinding();

};


#endif // #ifndef __SOT_SERVER_ABSTRACT_HH__
