# Francois Keith, Olivier Stasse, JRL, CNRS/AIST
# Creation: 25/06/2008
# History:
#
# Copyright CNRS/AIST
SET (libsot_dynamic_src )

SET (libsot_dynamic_templates "")

SET(libsot_dynamic_headers "")

SET(libsot_dynamic_plugins_templates "")
SET(libsot_dynamic_plugins_headers "")
SET(libsot_dynamic_plugins_src
dynamic/sotDynamic.cpp
dynamic/sotWaistAttitudeFromSensor.cpp
dynamic/sotZmprefFromCom.cpp	
dynamic/sotMassApparent.cpp
dynamic/sotIntegratorForce.cpp
dynamic/sotIntegratorForceRK4.cpp
dynamic/sotIntegratorForceExact.cpp
dynamic/sotForceCompensation.cpp
dynamic/sotAngleEstimator.cpp
dynamic/sotMatrixInertia.cpp
)

# plugins dependencies
SET (sotIntegratorForceRK4_plugins_dependencies sotIntegratorForce)
SET (sotIntegratorForceExact_plugins_dependencies sotIntegratorForce)
SET (sotDynamic_plugins_dependencies sotMatrixInertia)

IF (${hrp2Dynamics_FOUND})
  SET(libsot_dynamic_plugins_src ${libsot_dynamic_plugins_src} dynamic/sotDynamicHrp2.cpp)
  SET (sotDynamicHrp2_plugins_dependencies 
  sotMatrixInertia
  sotDynamic
  )
ENDIF(${hrp2Dynamics_FOUND})


FOREACH(srcfile ${libsot_dynamic_src} )
   SET(newsrcfile "")
   STRING(REGEX REPLACE "cpp$" "h" newsrcfile ${srcfile})
   SET(libsot_dynamic_headers ${newsrcfile} ${libsot_dynamic_headers})
ENDFOREACH(srcfile)

FOREACH(srcfile ${libsot_dynamic_plugins_src} )
   SET(newsrcfile "")
   STRING(REGEX REPLACE "cpp$" "h" newsrcfile ${srcfile})
   SET(libsot_dynamic_plugins_headers ${newsrcfile} ${libsot_dynamic_plugins_headers})
ENDFOREACH(srcfile)

SET(tempext "t\\.cpp")

FOREACH(srcfile ${libsot_dynamic_templates})
   SET(newsrcfile "")
   STRING(REGEX REPLACE "${tempext}$" "h" newsrcfile ${srcfile})
   SET(libsot_dynamic_headers ${newsrcfile} ${libsot_dynamic_headers})
ENDFOREACH(srcfile)

FOREACH(srcfile ${libsot_dynamic_plugins_templates})
   SET(newsrcfile "")
   STRING(REGEX REPLACE "${tempext}$" "h" newsrcfile ${srcfile})
   SET(libsot_dynamic_plugins_headers ${newsrcfile} ${libsot_dynamic_plugins_headers})
ENDFOREACH(srcfile)

#MESSAGE(STATUS "MatrixAbstractLayer_cflags: ${MatrixAbstractLayer_cflags}")

			
# SET(sotWaistAttitudeFromSensor_plugins_compile_flags "${MatrixAbstractLayer_cflags} ${dynamicsJRLJapan_cflags}")
# SET(sotAngleEstimator_plugins_compile_flags "${MatrixAbstractLayer_cflags}")
# SET(sotAngleEstimator_plugins_link_flags "${MatrixAbstractLayer_link_FLAGS}")

# SET(sotIntegratorForce_plugins_compile_flags "${MatrixAbstractLayer_cflags}")
# SET(sotIntegratorForceExact_plugins_compile_flags "${MatrixAbstractLayer_cflags}")
# SET(sotIntegratorForceRK4_plugins_compile_flags "${MatrixAbstractLayer_cflags}")
# SET(sotMassApparent_plugins_compile_flags "${MatrixAbstractLayer_cflags}")
# SET(sotZmprefFromCom_plugins_compile_flags "${MatrixAbstractLayer_cflags}")
# SET(sotForceCompensation_plugins_compile_flags "${MatrixAbstractLayer_cflags}")

SET (libsot_src ${libsot_src}
${libsot_dynamic_src}
)

SET (libsot_headers ${libsot_headers}
${libsot_dynamic_headers}
)

SET (libsot_templates ${libsot_templates}
${libsot_dynamic_templates}
)

SET (libsot_plugins_src ${libsot_plugins_src}
${libsot_dynamic_plugins_src}
)

SET (libsot_plugins_headers ${libsot_plugins_headers}
${libsot_dynamic_plugins_headers}
)

SET (libsot_plugins_templates ${libsot_plugins_templates}
${libsot_dynamic_plugins_templates}
)

# Specify the compile flags for each plugins.
SET (sotMatrixInertia_plugins_compile_flags "${dynamicsJRLJapan_cflags}" )
SET (sotMatrixInertia_plugins_link_flags "${dynamicsJRLJapan_link_FLAGS}" )


#MESSAGE(STATUS "in dynamic plugin : ${dynamicsJRLJapan_include_DIR}")
SET (sotDynamic_plugins_compile_flags "${dynamicsJRLJapan_cflags}" )
SET (sotDynamic_plugins_link_flags "${dynamicsJRLJapan_link_FLAGS}" )
SET (sotMatrixInertia_plugins_link_flags "${dynamicsJRLJapan_link_FLAGS}" )

# Specify the compile flags for each plugins.
IF (${hrp2Dynamics_FOUND})
SET (sotDynamicHrp2_plugins_compile_flags "${dynamicsJRLJapan_cflags} ${hrp2Dynamics_cflags}" )
SET (sotDynamicHrp2_plugins_link_flags "${dynamicsJRLJapan_link_FLAGS} ${hrp2Dynamics_link_FLAGS}" )
ENDIF (${hrp2Dynamics_FOUND})
