/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 * Copyright Projet JRL-Japan, 2007
 *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 *
 * File:      sotDynamic.h
 * Project:   SOT
 * Author:    Nicolas Mansard
 *
 * Version control
 * ===============
 *
 *  $Id$
 *
 * Description
 * ============
 *
 *
 * ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/

#include <sot/sotDynamicHrp2.h>
#include <sot/sotDebug.h>

#include <robotDynamics/jrlRobotDynamicsObjectConstructor.h>

#include <sot/sotFactory.h>


SOT_FACTORY_ENTITY_PLUGIN(sotDynamicHrp2,"DynamicHrp2");

sotDynamicHrp2::
sotDynamicHrp2( const std::string & name ) 
  :sotDynamic(name,false)
{
  sotDEBUGIN(15);
  sotDynamicHrp2::buildModelHrp2();
  sotDEBUGOUT(15);
}

void sotDynamicHrp2::
buildModelHrp2( void )
{
  sotDEBUGIN(15);

  CjrlRobotDynamicsObjectConstructor<
    dynamicsJRLJapan::DynamicMultiBody, 
    Chrp2OptHumanoidDynamicRobot,
    dynamicsJRLJapan::JointFreeflyer, 
    dynamicsJRLJapan::JointRotation,
    dynamicsJRLJapan::JointTranslation,
    dynamicsJRLJapan::Body> aRobotDynamicsObjectConstructor;
  
  aHDR = aRobotDynamicsObjectConstructor.createhumanoidDynamicRobot();
  aHDMB = dynamic_cast<djj::HumanoidDynamicMultiBody *>(aHDR);
  if( NULL == aHDMB )
    {
      SOT_THROW sotExceptionDynamic( sotExceptionDynamic::DYNAMIC_JRL,
				     "Error parsing aHDR to aHDMB.",
				     "(DJJ model creation process for object %s).",
				     getName().c_str());
    }

  sotDEBUGOUT(15);
}


sotDynamicHrp2::
~sotDynamicHrp2( void )
{
  sotDEBUGINOUT(5);
  return;
}

