/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 * Copyright Projet JRL-Japan, 2007
 *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 *
 * File:      sotDynamic.h
 * Project:   SOT
 * Author:    Nicolas Mansard
 *
 * Version control
 * ===============
 *
 *  $Id$
 *
 * Description
 * ============
 *
 *
 * ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/



#ifndef __SOT_DYNAMIC_HRP2_H__
#define __SOT_DYNAMIC_HRP2_H__

/* --------------------------------------------------------------------- */
/* --- INCLUDE --------------------------------------------------------- */
/* --------------------------------------------------------------------- */

/* SOT */
#include <sot/sotDynamic.h>

/* JRL dynamic */
#include <hrp2Dynamics/hrp2OptHumanoidDynamicRobot.h>

/* --------------------------------------------------------------------- */
/* --- API ------------------------------------------------------------- */
/* --------------------------------------------------------------------- */

#if defined (WIN32) 
#  if defined (sotDynamicHrp2_EXPORTS)
#    define SOTDYNAMICHRP2_EXPORT __declspec(dllexport)
#  else  
#    define SOTDYNAMICHRP2_EXPORT __declspec(dllimport)
#  endif 
#else
#  define SOTDYNAMICHRP2_EXPORT
#endif

/* --------------------------------------------------------------------- */
/* --- CLASS ----------------------------------------------------------- */
/* --------------------------------------------------------------------- */

/*! @ingroup signals
  \brief Modification of the classic dynamic class to get the
  optimized version of the kinematics computations.
*/
  
class SOTDYNAMICHRP2_EXPORT sotDynamicHrp2
:public sotDynamic
{

 public:
  static const std::string CLASS_NAME;

 public: /* --- CONSTRUCTION --- */

  sotDynamicHrp2( const std::string& name );
  virtual ~sotDynamicHrp2( void );

 public: /* --- MODEL CREATION --- */
 
   void buildModelHrp2( void );
  

};





#endif // #ifndef __SOT_DYNAMIC_HRP2_H__

