/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 * Copyright Projet JRL-Japan, 2007
 *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 *
 * File:      sotIntegratorForceRK4.h
 * Project:   SOT
 * Author:    Nicolas Mansard
 *
 * Version control
 * ===============
 *
 *  $Id$
 *
 * Description
 * ============
 *
 *
 * ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/



#ifndef __SOT_SOTINTEGRATORFORCERK4_H__
#define __SOT_SOTINTEGRATORFORCERK4_H__

/* --------------------------------------------------------------------- */
/* --- INCLUDE --------------------------------------------------------- */
/* --------------------------------------------------------------------- */

/* Matrix */
#include <MatrixAbstractLayer/boost.h>
namespace ml = maal::boost;

/* SOT */
#include <sot/sotEntity.h>
#include <sot/sotSignalPtr.h>
#include <sot/sotSignalTimeDependant.h>
#include <sot/sotMatrixHomogeneous.h>
#include <sot/sotVectorRollPitchYaw.h>
#include <sot/sotMatrixRotation.h>
#include <sot/sotIntegratorForce.h>

/* STD */
#include <string>

/* --------------------------------------------------------------------- */
/* --- API ------------------------------------------------------------- */
/* --------------------------------------------------------------------- */

#if defined (WIN32) 
#  if defined (sotIntegratorForceRK4_EXPORTS)
#    define SOTINTEGRATORFORCERK4_EXPORT __declspec(dllexport)
#  else  
#    define SOTINTEGRATORFORCERK4_EXPORT __declspec(dllimport)
#  endif 
#else
#  define SOTINTEGRATORFORCERK4_EXPORT
#endif

/* --------------------------------------------------------------------- */
/* --- CLASS ----------------------------------------------------------- */
/* --------------------------------------------------------------------- */

class SOTINTEGRATORFORCERK4_EXPORT sotIntegratorForceRK4
:public sotIntegratorForce
{
 public:
  static const std::string CLASS_NAME;

 protected:

 public: /* --- CONSTRUCTION --- */

  sotIntegratorForceRK4( const std::string& name );
  virtual ~sotIntegratorForceRK4( void );

 public: /* --- SIGNAL --- */


 public: /* --- FUNCTIONS --- */
  ml::Vector& computeDerivativeRK4( ml::Vector& res,
				    const int& time );
  
/*  public: /\* --- PARAMS --- *\/ */
/*   virtual void commandLine( const std::string& cmdLine, */
/* 			    std::istringstream& cmdArgs, */
/* 			    std::ostream& os ); */
    

};






#endif // #ifndef __SOT_SOTINTEGRATORFORCERK4_H__

