/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 * Copyright Projet JRL-Japan, 2008
 *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 *
 * File:      sotExceptionPatternGenerator.h
 * Project:   SOT
 * Author:    Olivier Stasse
 *
 * Version control
 * ===============
 *
 *  $Id$
 *
 * Description
 * ============
 *
 *
 * ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/


#ifndef __SOT_PATTERN_GENERATOR_EXCEPTION_H
#define __SOT_PATTERN_GENERATOR_EXCEPTION_H

/* --------------------------------------------------------------------- */
/* --- INCLUDE --------------------------------------------------------- */
/* --------------------------------------------------------------------- */


#include <sot/sotExceptionAbstract.h>
#include <sot/sot-0API.h>

/* --------------------------------------------------------------------- */
/* --- CLASS ----------------------------------------------------------- */
/* --------------------------------------------------------------------- */


/* \class sotExceptionPatternGenerator
 */
class SOT_EXPORT sotExceptionPatternGenerator 
:public sotExceptionAbstract

{
 public:
  enum ErrorCodeEnum
    {
      GENERIC = sotExceptionAbstract::PATTERN_GENERATOR
      ,READ_FILE
      ,CANT_DESTROY_SIGNAL
      ,JOINT_RANK
      ,PATTERN_GENERATOR_JRL
      ,SELECTOR_RANK
      ,BAD_CAST
    };

  static const std::string EXCEPTION_NAME;
  virtual const std::string& getExceptionName( void ) const { return EXCEPTION_NAME; }
  
public:

  sotExceptionPatternGenerator ( const sotExceptionPatternGenerator::ErrorCodeEnum& errcode,
		       const std::string & msg = "" );
  sotExceptionPatternGenerator( const sotExceptionPatternGenerator::ErrorCodeEnum& errcode,
			const std::string & msg,const char* format, ... );
  virtual ~sotExceptionPatternGenerator( void ){}


};





#endif /* #ifndef __SOT_PATTERN_GENERATOR_EXCEPTION_H */

