/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 * Copyright Projet JRL-Japan, 2007
 *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 *
 * File:      sotOpPointModifior.h
 * Project:   SOT
 * Author:    Nicolas Mansard
 *
 * Version control
 * ===============
 *
 *  $Id$
 *
 * Description
 * ============
 *
 *
 * ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/

#ifndef __SOT_OP_POINT_MODIFIOR_H__
#define __SOT_OP_POINT_MODIFIOR_H__

#include <sot/sotEntity.h>

#include <sot/sotSignalTimeDependant.h>
#include <sot/sotSignalPtr.h>

/* Matrix */
#include <MatrixAbstractLayer/boost.h>
namespace ml = maal::boost;

/* --------------------------------------------------------------------- */
/* --- API ------------------------------------------------------------- */
/* --------------------------------------------------------------------- */

#if defined (WIN32) 
#  if defined (sotOpPointModifior_EXPORTS)
#    define SOTOPPOINTMODIFIOR_EXPORT __declspec(dllexport)
#  else  
#    define SOTOPPOINTMODIFIOR_EXPORT __declspec(dllimport)
#  endif 
#else
#  define SOTOPPOINTMODIFIOR_EXPORT
#endif

/* --------------------------------------------------------------------- */
/* --- VECTOR ---------------------------------------------------------- */
/* --------------------------------------------------------------------- */
class SOTOPPOINTMODIFIOR_EXPORT sotOpPointModifior
: public sotEntity
{
 public:
  static const std::string CLASS_NAME;
  virtual const std::string& getClassName( void ) { return CLASS_NAME; }
  
  sotMatrixHomogeneous transformation;

 public:

  sotSignalPtr<ml::Matrix,int> jacobianSIN;
  sotSignalPtr<sotMatrixHomogeneous,int> positionSIN;
  
  sotSignalTimeDependant<ml::Matrix,int> jacobianSOUT;
  sotSignalTimeDependant<sotMatrixHomogeneous,int> positionSOUT;

public:
  sotOpPointModifior( const std::string& name );

  virtual ~sotOpPointModifior( void ){}

  ml::Matrix& computeJacobian( ml::Matrix& res,const int& time );
  sotMatrixHomogeneous& computePosition( sotMatrixHomogeneous& res,const int& time );
  void setTransformation( const sotMatrixHomogeneous& tr );

  virtual void commandLine( const std::string& cmdLine,
			    std::istringstream& cmdArgs, 
			    std::ostream& os );

};


#endif //  __SOT_OP_POINT_MODIFIOR_H__ 