/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 * Copyright Projet JRL-Japan, 2007
 *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 *
 * File:      sotMatrixConstant.h
 * Project:   SOT
 * Author:    Nicolas Mansard
 *
 * Version control
 * ===============
 *
 *  $Id$
 *
 * Description
 * ============
 *
 *
 * ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/

#include <sot/sotEntity.h>

#include <sot/sotFactory.h>

/* --------------------------------------------------------------------- */
/* --- MATRIX ---------------------------------------------------------- */
/* --------------------------------------------------------------------- */
class sotMatrixConstant
: public sotEntity
{
public:
  sotMatrixConstant( const std::string& name )
    :sotEntity( name )
    ,SOUT( "sotMatrixConstant("+name+")::output(matrix)::out" )
    {
      SOUT.setDependancyType( sotTimeDependancy::BOOL_DEPENDANT );
    }

  virtual ~sotMatrixConstant( void ){}

  sotSignalTimeDependant<ml::Matrix,int> SOUT;

  virtual void commandLine( const std::string& cmdLine,
			    std::istringstream& cmdArgs, 
			    std::ostream& os );

};
    






