/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 * Copyright Projet JRL-Japan, 2007
 *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 *
 * File:      sotVectorConstant.h
 * Project:   SOT
 * Author:    Nicolas Mansard
 *
 * Version control
 * ===============
 *
 *  $Id$
 *
 * Description
 * ============
 *
 *
 * ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/

#include <sot/sotEntity.h>

#include <sot/sotSignalTimeDependant.h>

/* Matrix */
#include <MatrixAbstractLayer/boost.h>
namespace ml = maal::boost;

/* --------------------------------------------------------------------- */
/* --- VECTOR ---------------------------------------------------------- */
/* --------------------------------------------------------------------- */
class sotVectorConstant
: public sotEntity
{
  static const std::string CLASS_NAME;
  virtual const std::string& getClassName( void ) { return CLASS_NAME; }

  int rows;
  double color;

public:
  sotVectorConstant( const std::string& name )
    :sotEntity( name )
    ,rows(0),color(0.)
    ,SOUT( "sotVectorConstant("+name+")::output(vector)::out" )
    {
      SOUT.setDependancyType( sotTimeDependancy<int>::BOOL_DEPENDANT );
      signalRegistration( SOUT );
    }

  virtual ~sotVectorConstant( void ){}

  sotSignalTimeDependant<ml::Vector,int> SOUT;

  virtual void commandLine( const std::string& cmdLine,
			    std::istringstream& cmdArgs, 
			    std::ostream& os );

};
    






