/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 * Copyright Projet JRL-Japan, 2007
 *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 *
 * File:      sotTaskPD.h
 * Project:   SOT
 * Author:    Nicolas Mansard
 *
 * Version control
 * ===============
 *
 *  $Id$
 *
 * Description
 * ============
 *
 *
 * ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/



#ifndef __SOT_TASK_PD_H__
#define __SOT_TASK_PD_H__

/* --------------------------------------------------------------------- */
/* --- INCLUDE --------------------------------------------------------- */
/* --------------------------------------------------------------------- */


/* SOT */
#include <sot/sotTask.h>

/* --------------------------------------------------------------------- */
/* --- API ------------------------------------------------------------- */
/* --------------------------------------------------------------------- */

#if defined (WIN32) 
#  if defined (sotTaskPD_EXPORTS) 
#    define SOTTASKPD_EXPORT __declspec(dllexport)
#  else  
#    define SOTTASKPD_EXPORT __declspec(dllimport)
#  endif 
#else
#  define SOTTASKPD_EXPORT
#endif

/* --------------------------------------------------------------------- */
/* --- CLASS ----------------------------------------------------------- */
/* --------------------------------------------------------------------- */



class SOTTASKPD_EXPORT sotTaskPD
: public sotTask
{
 public: 
  static const std::string CLASS_NAME;
  virtual const std::string& getClassName( void ) { return CLASS_NAME; }

  ml::Vector previousError;
  double beta;

 public:
  sotTaskPD( const std::string& n );


  /* --- COMPUTATION --- */
  ml::Vector& computeErrorDot( ml::Vector& error,int time );
  ml::Vector& computeTaskModif( ml::Vector& error,int time );
  

  /* --- SIGNALS ------------------------------------------------------------ */
 public:
  sotSignalTimeDependant< ml::Vector,int > errorDotSOUT;
  sotSignalPtr< ml::Vector,int > errorDotSIN;
  
  /* --- PARAMS --- */
  virtual void commandLine( const std::string& cmdLine
			    ,std::istringstream& cmdArgs
			    ,std::ostream& os );


};





#endif /* #ifndef __SOT_TASK_PD_H__ */


