/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 * Copyright Projet JRL-Japan, 2007
 *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 *
 * File:      sotTaskLearningTools.h
 * Project:   SOT
 * Author:    Paul Evrard
 *
 * Version control
 * ===============
 *
 *  $Id$
 *
 * Description
 * ============
 *
 * Tools for task learning wrapper.
 *
 * ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/

template<class T>
void readElm(std::istringstream& cmdArgs, std::ostream& os,
	     const char* name, T& elm)
{
  T tmp;
  if(cmdArgs>>tmp){ elm = tmp; }
  os << name << ": " << elm << endl;
}

template<int N>
void readVector(std::istringstream& cmdArgs, std::ostream& os,
		const char* name, ml::Vector& v)
{
  int i = 0;
  double tmp[N];
  for( ; (i<N) && (cmdArgs>>tmp[i]); ++i ){ /*nothing to do here*/ }

  if(i && (i != N)){ os << "syntax error" << endl; }
  else if(i){ for( int i=0;i<N;++i ){ v(i) = tmp[i]; } }

  os << name << ": ";
  for( int i=0;i<N;++i){ os << v(i) << ", "; }
  os << std::endl;
}

template<class T>
bool between(T val, T lower, T upper)
{
  return (val > lower) && (val < upper);
}
