SET(libsot_tools_headers)
SET(libsot_tools_src
tools/sotPeriodicCall.cpp
tools/sotUtilsWindows.cpp
)

SET(libsot_tools_templates 
tools/sotMailbox.t.cpp
)

SET(libsot_tools_plugins_headers)

SET(libsot_tools_plugins_templates
tools/sotMailbox.t.cpp
)

SET(libsot_tools_plugins_src
tools/sotTimer.cpp
tools/sotMailbox.cpp
tools/sotNeckLimitation.cpp
tools/sotDistantShell.cpp
tools/sotSeqPlay.cpp
tools/sotRobotSimu.cpp
tools/sotPeriodicCallEntity.cpp
tools/sotJointLimitator.cpp
tools/sotKalman.cpp
tools/sotTimeStamp.cpp
tools/sotGripperControl.cpp
tools/sotSequencer.cpp
tools/sotMotionPeriod.cpp
)

IF(USE_COLLISION)
  SET(libsot_tools_plugins_src ${libsot_tools_plugins_src} tools/sotCollisionDetector.cpp)
ENDIF(USE_COLLISION)

# plugins dependencies
SET (sotDistantShell_plugins_dependencies sotContiifstream)
SET (sotSequencer_plugins_dependencies sotSOT)

FOREACH(srcfile ${libsot_tools_src})
   SET(newsrcfile "")
   STRING(REGEX REPLACE "cpp$" "h" newsrcfile ${srcfile})
   SET(libsot_tools_headers ${newsrcfile} ${libsot_tools_headers})
ENDFOREACH(srcfile)

FOREACH(srcfile ${libsot_tools_plugins_src})
   SET(newsrcfile "")
   STRING(REGEX REPLACE "cpp$" "h" newsrcfile ${srcfile})
   SET(libsot_tools_plugins_headers ${newsrcfile} ${libsot_tools_plugins_headers})
ENDFOREACH(srcfile)

SET(tempext "t\\.cpp")

FOREACH(srcfile ${libsot_tools_templates})
   SET(newsrcfile "")
   STRING(REGEX REPLACE "${tempext}$" "h" newsrcfile ${srcfile})
   SET(libsot_tools_headers ${newsrcfile} ${libsot_tools_headers})
#   MESSAGE(STATUS "newsrcfile: " ${newsrcfile})
ENDFOREACH(srcfile)


FOREACH(srcfile ${libsot_tools_plugins_templates})
   SET(newsrcfile "")
   STRING(REGEX REPLACE "${tempext}$" "h" newsrcfile ${srcfile})
   SET(libsot_tools_headers ${newsrcfile} ${libsot_tools_headers})
#   MESSAGE(STATUS "newsrcfile: " ${newsrcfile})
ENDFOREACH(srcfile)


# # Specify the compile flags for source file.
# SET_SOURCE_FILES_PROPERTIES (tools/sotSeqPlay.cpp 
			     # tools/sotPeriodicCallEntity.cpp
			     # tools/sotNeckLimitation.cpp
			     # tools/sotSequencer.cpp
			     # tools/sotGripperControl.cpp
			     # tools/sotTimer.cpp
			     # tools/sotTimeStamp.cpp 
			     # tools/sotRobotSimu.cpp	
			     # tools/sotJointLimitator.cpp	
			     # PROPERTIES 	 
			     # COMPILE_FLAGS "${MatrixAbstractLayer_cflags}" )

# SET_SOURCE_FILES_PROPERTIES (tools/sotDistantShell.cpp 
			     # tools/sotMailbox.cpp
			     # PROPERTIES 	 
			     # COMPILE_FLAGS "-pthread ${MatrixAbstractLayer_cflags}" )

SET (sotMailbox_plugins_link_flags "${BOOST_THREAD_LIB_NAME}")
SET (sotMailbox_plugins_compile_flags "-pthread ")

SET (sotPeriodicCallEntity_plugins_link_flags "${BOOST_THREAD_LIB_NAME}")
SET (sotPeriodicCallEntity_plugins_compile_flags "-pthread ")

SET (sotDistantShell_plugins_link_flags "${BOOST_THREAD_LIB_NAME}")
SET (sotDistantShell_plugins_compile_flags "-pthread ")

IF(USE_COLLISION)
  FOREACH(option_cxxflags ${COLLISIONDETECTION_CFLAGS})
    SET (sotCollisionDetector_plugins_compile_flags "${sotCollisionDetector_plugins_compile_flags} ${option_cxxflags}")
  ENDFOREACH(option_cxxflags)

  FOREACH(option_ldflags ${COLLISIONDETECTION_LDFLAGS})
    SET (sotCollisionDetector_plugins_link_flags "${sotCollisionDetector_plugins_link_flags} ${option_ldflags}")
  ENDFOREACH(option_ldflags)
ENDIF(USE_COLLISION)

# SET (sotKalman_plugins_compile_flags "${MatrixAbstractLayer_cflags}")

SET (libsot_src ${libsot_src}
${libsot_tools_src}
)

SET (libsot_headers ${libsot_headers}
${libsot_tools_headers}
)

SET (libsot_templates ${libsot_templates}
${libsot_tools_templates}
)

SET (libsot_plugins_src ${libsot_plugins_src}
${libsot_tools_plugins_src}
)

SET (libsot_plugins_headers ${libsot_plugins_headers}
${libsot_tools_plugins_headers}
)

SET (libsot_plugins_templates ${libsot_plugins_templates}
${libsot_tools_plugins_templates}
)
