/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 * Copyright Projet JRL-Japan, 2007
 *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 *
 * File:      sotBinaryIntToUint.cpp
 * Project:   SOT
 * Author:    Paul Evrard
 *
 * Version control
 * ===============
 *
 *  $Id$
 *
 * Description
 * ============
 *
 *
 * ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/

/* --- SOT --- */
#include <sot/sotPool.h>
#include <sot/sotBinaryIntToUint.h>
#include <sot/sotExceptionFeature.h>
#include <sot/sotDebug.h>
using namespace std;

#include <sot/sotFactory.h>
SOT_FACTORY_ENTITY_PLUGIN(sotBinaryIntToUint,"BinaryIntToUint");

/* --------------------------------------------------------------------- */
/* --- CLASS ----------------------------------------------------------- */
/* --------------------------------------------------------------------- */

sotBinaryIntToUint::sotBinaryIntToUint( const string& fname )
  : sotEntity( fname)
  ,binaryIntSIN( NULL,"sotBinaryIntToUint("+name+")::input(int)::in" )
  ,binaryUintSOUT( boost::bind(&sotBinaryIntToUint::computeOutput,this,_1,_2),
		   binaryIntSIN,
		   "sotBinaryIntToUint("+name+")::output(unsigned int)::out" )
{
  signalRegistration( binaryIntSIN<<binaryUintSOUT );
}

/* --------------------------------------------------------------------- */
/* --------------------------------------------------------------------- */
/* --------------------------------------------------------------------- */

unsigned& sotBinaryIntToUint::computeOutput( unsigned& res,int time )
{
  sotDEBUGIN(15);

  int in = binaryIntSIN.access(time);
  if(in < 0){ res = 0; }
  else{ res = 1; }

  sotDEBUGOUT(15);
  return res;
}

void sotBinaryIntToUint::display( std::ostream& os ) const
{
  os << "BinaryIntToUint <" << name << "> TODO..." << endl;
}

void sotBinaryIntToUint::
commandLine( const std::string& cmdLine,
	     std::istringstream& cmdArgs,
	     std::ostream& os )
{
  if( cmdLine == "help" )
  {
    os << "BinaryIntToUint: "<<endl;
  }
  else{ sotEntity::commandLine( cmdLine,cmdArgs,os ); }
}
