/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 * Copyright Projet JRL-Japan, 2007
 *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 *
 * File:      sotPeriodicCall.cpp
 * Project:   SOT
 * Author:    Nicolas Mansard
 *
 * Version control
 * ===============
 *
 *  $Id$
 *
 * Description
 * ============
 *
 *
 * ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/


/* --------------------------------------------------------------------- */
/* --- INCLUDE --------------------------------------------------------- */
/* --------------------------------------------------------------------- */

/* --- SOT --- */
#include <sot/sotPeriodicCallEntity.h>
#include <sot/sotPool.h>
#include <sot/sotInterpretor.h>
#include <sot/sotDebug.h>

using namespace std;

#include <sot/sotFactory.h>
SOT_FACTORY_ENTITY_PLUGIN(sotPeriodicCallEntity,"PeriodicCallEntity");

/* --------------------------------------------------------------------- */
/* --- CLASS ----------------------------------------------------------- */
/* --------------------------------------------------------------------- */



sotPeriodicCallEntity::
sotPeriodicCallEntity( const string& fName )
  : sotEntity( fName )  
  ,sotPeriodicCall()
  ,triger( "Tracer("+fName+")::triger" )
  ,trigerOnce( "Tracer("+fName+")::trigerOnce" )
{
  signalRegistration( triger << trigerOnce );

  triger.setFunction( boost::bind(&sotPeriodicCallEntity::trigerCall,this,_1,_2) );
  trigerOnce.setFunction( boost::bind(&sotPeriodicCallEntity::trigerOnceCall,
				      this,_1,_2) );

}  

int& sotPeriodicCallEntity::
trigerCall( int& dummy,const int & time )
{
  run(time);
  return dummy;
}
int& sotPeriodicCallEntity::
trigerOnceCall( int& dummy,const int & time )
{
  run( time );
  clear();
  return dummy;
}


/* --------------------------------------------------------------------- */
/* --------------------------------------------------------------------- */
/* --------------------------------------------------------------------- */


void sotPeriodicCallEntity::
display( std::ostream& os ) const
{
  os << "PeriodicCallEntity <"<<name<<"> ";
  sotPeriodicCall::display( os );
}




void sotPeriodicCallEntity::
commandLine( const std::string& cmdLine,
	     std::istringstream& cmdArgs,
	     std::ostream& os )
{
  if(! sotPeriodicCall::commandLine( cmdLine,cmdArgs,os) )
    { sotEntity::commandLine( cmdLine,cmdArgs,os ); }
}



/*
 * Local variables:
 * c-basic-offset: 2
 * End:
 */

