/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 * Copyright Projet JRL-Japan, 2007
 *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 *
 * File:      sotPeriodicCall.h
 * Project:   SOT
 * Author:    Nicolas Mansard
 *
 * Version control
 * ===============
 *
 *  $Id$
 *
 * Description
 * ============
 *
 *
 * ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/


#ifndef __SOT_PERIODICCALL_ENTITY_HH__
#define __SOT_PERIODICCALL_ENTITY_HH__

/* --------------------------------------------------------------------- */
/* --- INCLUDE --------------------------------------------------------- */
/* --------------------------------------------------------------------- */


/* SOT */
#include <sot/sotEntity.h>
#include <sot/sotPeriodicCall.h>
#include <sot/sotSignalAbstract.h>
#include <sot/sotSignal.h>
/* STD */
#include <list>
#include <map>
#include <string>

/* --------------------------------------------------------------------- */
/* --- API ------------------------------------------------------------- */
/* --------------------------------------------------------------------- */

#if defined (WIN32) 
#  if defined (sotPeriodicCallEntity_EXPORTS)
#    define SOTPERIODICCALLENTITY_EXPORT __declspec(dllexport)
#  else  
#    define SOTPERIODICCALLENTITY_EXPORT __declspec(dllimport)
#  endif 
#else
#  define SOTPERIODICCALLENTITY_EXPORT
#endif

/* --------------------------------------------------------------------- */
/* --- CLASS ----------------------------------------------------------- */
/* --------------------------------------------------------------------- */


/*!
  \class sotPeriodicCallEntity
*/
class SOTPERIODICCALLENTITY_EXPORT sotPeriodicCallEntity 
: public sotEntity, protected sotPeriodicCall
{

 public: 
  static const std::string CLASS_NAME;
  virtual const std::string& getClassName( void ) { return CLASS_NAME; }

  sotSignal<int,int> triger; 
  sotSignal<int,int> trigerOnce; 

  int& trigerCall( int& dummy,const int & time );
  int& trigerOnceCall( int& dummy,const int & time );

  /* --- FUNCTIONS ------------------------------------------------------------ */
 public:
  sotPeriodicCallEntity( const std::string& name );
  virtual ~sotPeriodicCallEntity( void ) {}

  virtual void display( std::ostream& os ) const;
  void commandLine( const std::string& cmdLine,
		    std::istringstream& cmdArgs,
		    std::ostream& os );
} ;

#endif // #ifndef __SOT_PERIODICCALL_ENTITY_HH__

/*
 * Local variables:
 * c-basic-offset: 2
 * End:
 */
