/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 * Copyright Projet JRL-Japan, 2007
 *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 *
 * File:      sotSeqPlay.h
 * Project:   SOT
 * Author:    Nicolas Mansard
 *
 * Version control
 * ===============
 *
 *  $Id$
 *
 * Description
 * ============
 *
 *
 * ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/



#ifndef __SOT_SEQPLAY_HH
#define __SOT_SEQPLAY_HH

/* --------------------------------------------------------------------- */
/* --- INCLUDE --------------------------------------------------------- */
/* --------------------------------------------------------------------- */

/* -- MaaL --- */
#include <MatrixAbstractLayer/boost.h>
namespace ml= maal::boost;
/* SOT */
#include <sot/sotEntity.h>
#include <sot/sotSignal.h>
#include <sot/sotSignalTimeDependant.h>
#include <sot/sotSignalPtr.h>

#include <list>

/* --------------------------------------------------------------------- */
/* --- API ------------------------------------------------------------- */
/* --------------------------------------------------------------------- */

#if defined (WIN32) 
#  if defined (sotSeqPlay_EXPORTS)
#    define SOTSEQPLAY_EXPORT __declspec(dllexport)
#  else  
#    define SOTSEQPLAY_EXPORT __declspec(dllimport)
#  endif 
#else
#  define SOTSEQPLAY_EXPORT
#endif

/* --------------------------------------------------------------------- */
/* --- CLASS ----------------------------------------------------------- */
/* --------------------------------------------------------------------- */

class SOTSEQPLAY_EXPORT sotSeqPlay
:public sotEntity
{
 public:
  static const std::string CLASS_NAME;
  virtual const std::string& getClassName( void ) const { return CLASS_NAME; }

 protected:
  
  typedef  std::list<ml::Vector> StateList;
  StateList stateList;
  StateList::iterator currPos; unsigned int currRank;
  bool init; 
  int time;

 public:
  
  /* --- CONSTRUCTION --- */
  sotSeqPlay( const std::string& name );
  virtual ~sotSeqPlay( void ) { }

  void loadFile( const std::string& name );

  ml::Vector& getNextPosition( ml::Vector& pos, const int& time );

 public: /* --- DISPLAY --- */
  virtual void display( std::ostream& os ) const;
  SOTSEQPLAY_EXPORT friend std::ostream& operator<< ( std::ostream& os,const sotSeqPlay& r ) 
    { r.display(os); return os;}

 public: /* --- SIGNALS --- */

  //sotSignalPtr<ml::Vector,int> positionSIN;
  //sotSignalTimeDependant<ml::Vector,int> velocitySOUT;
  sotSignalTimeDependant<int,int> refresherSINTERN;
  sotSignalTimeDependant<ml::Vector,int> positionSOUT;

 public: /* --- COMMANDS --- */
  virtual void commandLine( const std::string& cmdLine,std::istringstream& cmdArgs,
			    std::ostream& os );

};



#endif /* #ifndef __SOT_SEQPLAY_HH */




