/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 * Copyright Projet JRL 2007
 *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 *
 * File:      test_flags.cc
 * Project:   sot
 * Author:    Nicolas Mansard
 *
 * Version control
 * ===============
 *
 *  $Id$
 *
 * Description
 * ============
 *
 *
 * ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/

/* -------------------------------------------------------------------------- */
/* --- INCLUDES ------------------------------------------------------------- */
/* -------------------------------------------------------------------------- */
#include <sot/sotDynamicHrp2.h>
#include <sot/sotDebug.h>
#include "../../src/dynamic/sotMatrixInertia.h"
#include <iostream>
#include <sstream>

using namespace std;

#include <sys/time.h>

#define sotCOUNTER(nbc1,nbc2) \
	  gettimeofday(&tpart##nbc2,NULL); \
	  dt##nbc2 += ( (tpart##nbc2.tv_sec-tpart##nbc1.tv_sec) * 1000. \
		   + (tpart##nbc2.tv_usec-tpart##nbc1.tv_usec+0.) / 1000. );
//#define sotCOUNTER(nbc1,nbc2)
#define sotINITCOUNTER(nbc1) \
   struct timeval tpart##nbc1; double dt##nbc1=0; 




int main( void )
{
//   sotMatrixHomogeneous M; 
//   M(0,0) =  0.697825;
//   M(0,1) =  0;
//   M(0,2) =  0.716268;
//   M(0,3) = 0;
  
//   M(1,0) = 0;
//   M(1,1) = 1;
//   M(1,2) =  0;
//   M(1,3) =  0;

//   M(2,0) = -0.716268;
//   M(2,1) =  0;
//   M(2,2) =  0.697825;
//   M(2,3) =  -0.3;

//   sotMatrixHomogeneous Mi; M.inverse(Mi);
//   cout << ml::MATLAB << M << endl;
//   cout << Mi << endl;
//   exit(0);
  try{
    sotDEBUG(1) << "# In" << std::endl;


    sotDEBUG(1) << "Create toto" << std::endl;
    sotDynamic * dyn = new sotDynamic("tot");
    sotDEBUG(1) << "Setup toto" << std::endl;
    dyn->setVrmlDirectory("model/");
    dyn->setXmlSpecificityFile("HRP2Specificities.xml");
    dyn->setXmlRankFile("HRP2LinkJointRankSmall.xml");
    dyn->setVrmlMainFile("HRP2JRLmainsmall.wrl");
    sotDEBUG(1) << "Parse toto" << std::endl;
    dyn->parseConfigFiles();
    
    sotMatrixInertia dynert( dyn->aHDR );
    ml::Vector q(36); q.fill(0.);
    for( unsigned int i=6;i<36;++i ) q(i)=rand()/(RAND_MAX+.0);
    
    dyn->comActivation( true );
    ml::Vector q0(36); q0.fill(0);
    dyn->jointVelocitySIN = q0;
    dyn->jointAccelerationSIN = q0;
    dyn->jointPositionSIN = q; 
    
    dyn->newtonEulerSINTERN( 0 );
    sotDEBUG(25) << "q = [ " << q << endl;
    

    sotINITCOUNTER(0);
    sotINITCOUNTER(1);
    sotINITCOUNTER(2);
    gettimeofday(&tpart0,NULL);
    
    dynert.update();
    dynert.computeInertiaMatrix();
    
    sotCOUNTER(0,1);
    cout << "dt = " << dt1 << std::endl;


    for( int i=0;i<100000;i++)
      {
	dynert.update();
	dynert.computeInertiaMatrix();
      }
    sotCOUNTER(1,2);

    cout << "dt x 1000 = " << dt2 << std::endl;

    sotDEBUG(1) <<std::endl;
    const ml::Matrix &A = dynert.getInertiaMatrix( );
    sotDEBUG(1) << ml::MATLAB <<  A << endl;
    sotDEBUG(1) << ml::MATLAB<< dyn->JcomSOUT( 0 ) << endl;

  }catch( sotExceptionAbstract & e ) { cout << e << endl; }


  return 0;
}
