/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 * Copyright Projet JRL-JAPAN, Tsukuba, 2007
 *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 *
 * File:      test_shell.cc
 * Project:   SOT
 * Author:    Nicolas Mansard
 *
 * Version control
 * ===============
 *
 *  $Id$
 *
 * Description
 * ============
 *
 *
 * ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/

/* -------------------------------------------------------------------------- */
/* --- INCLUDES ------------------------------------------------------------- */
/* -------------------------------------------------------------------------- */

#include <sot/sotFactory.h>
#include <sot/sotEntity.h>
#include <sot/sotFeatureAbstract.h>

#include <sot/sotPluginLoader.h>
#include <sot/sotInterpretor.h>

#include <sot/sotDebug.h>

#include <sstream>
using namespace std;


extern std::ofstream debugfile;

int main( int argc,char** argv )
{
  sotDEBUGIN(15);
  
  sotDEBUG(5) << " Loading..." << endl;
  sotPluginLoader pl;
  sotShell.referencePluginLoader( &pl );

  int fileIdx;
  try
    {
      for( fileIdx=1;fileIdx<argc;++fileIdx )
	{
	  std::istringstream script( argv[fileIdx] );
	  cout << "Run "<< argv[fileIdx] << endl;
	  sotShell.cmd( "run",script,cout );
	}
    } 
  catch( sotExceptionAbstract& e )
    {
      cout << "!! In file <" << argv[fileIdx] << "> : "  << e <<endl;
    }
  catch( ... ){ sotDEBUG(5) << "!! Unknown! " <<endl ; }
 
  while(1)
    {
      try
	{
	  sotDEBUG(5) << "Run shell." << endl;
	  sotShell.shell(cin,cout);
	  sotDEBUG(5) << "Shell over." << endl;
      if( cin.eof() ) break;
	} 
      catch( sotExceptionAbstract& e )
	{
	  cout << "!!  "  << e <<endl;
	}
      catch( ... ){ sotDEBUG(5) << "!! Unknown! " <<endl ; }      
    }

  sotDEBUGOUT(15);
  return 0;
}




