/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 * Copyright Projet JRL-Japan, Tsukuba, 2007
 *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 *
 * File:      test_array.cpp
 * Project:   SOT
 * Author:    Nicolas Mansard
 *
 * Version control
 * ===============
 *
 *  $Id: test_boost.cpp,v 1.1.1.1 2006-07-03 05:17:37 nmansard Exp $
 *
 * Description
 * ============
 *
 *
 * ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/

#include <sot/sotSignalArray.h>
#include <sot/sotSignal.h>
#include <sot/sotDebug.h>

using namespace std;


void f_const( const sotSignalArray_const<int>& array )
{
  sotDEBUG(1) << "const_array ["<<array.getSize()<<"] ---"<<endl;
  for( unsigned int i=0;i<array.getSize();++i )
    {
      sotDEBUG(1) << "CONST[" <<i<<"]"<< array[i].getName() <<endl;
    }
}
void f( const sotSignalArray<int>& array )
{
  sotDEBUG(1) << "array ---"<<endl;
  for( unsigned int i=0;i<array.getSize();++i )
    {
      sotDEBUG(1) << "[" <<i<<"]"<< array[i].getName() <<endl;
    }
}
int main( void )
{
  sotSignal<int,int> sig1("Sig1");
  sotSignal<int,int> sig2("Sig2");
  sotSignal<int,int> sig3("Sig3");

  const sotSignal<int,int> sig4("constSig4");
  const sotSignal<int,int> sig5("constSig5");
  const sotSignal<int,int> sig6("constSig6");

  sotSignalArray<int> sigarr( sig4 );
  sotSignalArray_const<int> sigarr2( sigarr );


  sotDEBUG(1)<<"fc 123"<<endl;
  f_const(sig1<<sig2<<sig3); 
  sotDEBUG(1)<<"f 123"<<endl;
  f(sig1<<sig2<<sig3);

  sotDEBUG(1)<<"fc 456"<<endl;
  f_const( sig4<<sig5<<sig6 );
  sotDEBUG(1)<<"f 456"<<endl;
  // f( sig4<<sig5<<sig6 ); // f requiere a non-const

  sotDEBUG(1)<<"fc 156"<<endl;
  f_const( sig1<<sig5<<sig6 );
  sotDEBUG(1)<<"f 156"<<endl;
  //f( sig1<<sig5<<sig6 ); //f requiere a non-const

  sotDEBUG(1)<<"fc 416"<<endl;
  f_const( sig4<<sig1<<sig6 );
  sotDEBUG(1)<<"f 416"<<endl;
  //f( sig4<<sig1<<sig6 ); //f requiere a non-const

			   

}


