/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 * Copyright Projet JRL-JAPAN, Tsukuba, 2007
 *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 *
 * File:      test_ptr.cc
 * Project:   Stack Of Tasks
 * Author:    Nicolas Mansard
 *
 * Version control
 * ===============
 *
 *  $Id$
 *
 * Description
 * ============
 *
 *
 * ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/

/* -------------------------------------------------------------------------- */
/* --- INCLUDES ------------------------------------------------------------- */
/* -------------------------------------------------------------------------- */
#include <sot/sotSignalPtr.h>
#include <sot/sotDebug.h>
#include <sot/sotSignalTimeDependant.h>
#include <iostream>

#include <MatrixAbstractLayer/boost.h>
#include <sot/sotVectorUTheta.h>

using namespace std;

namespace ml = maal::boost;




template< class Res=double >
class DummyClass
{

public:
  DummyClass( void ) : res(),appel(0),timedata(0) {}

  Res& fun( Res& res,int t) 
  {
    appel++;  timedata=t; 

    sotDEBUG(5) << "Inside " << typeid(Res).name() <<endl;
    for( list< sotSignalTimeDependant<double,int>* >::iterator it=inputsig.begin();
	 it!=inputsig.end();++it )
       { sotDEBUG(5) << *(*it) << endl; (*it)->access(timedata);}
    for( list< sotSignalTimeDependant<ml::Vector,int>* >::iterator it=inputsigV.begin();
	 it!=inputsigV.end();++it )
      { sotDEBUG(5) << *(*it) << endl; (*it)->access(timedata);}

    return res=(*this)();
  }

  list< sotSignalTimeDependant<double,int>* > inputsig;
  list< sotSignalTimeDependant<ml::Vector,int>* > inputsigV;

  void add( sotSignalTimeDependant<double,int>& sig ){ inputsig.push_back(&sig); }
  void add( sotSignalTimeDependant<ml::Vector,int>& sig ){ inputsigV.push_back(&sig); }

  Res operator() ( void );

  Res res;
  int appel;
  int timedata;
  
};

template< class Res >
Res DummyClass<Res>::operator() (void)
{ return this->res; }

template<>
double DummyClass<double>::operator() (void)
{
  res=appel*timedata; return res;
}
template<>
ml::Vector DummyClass<ml::Vector>::operator() (void)
{
  res.resize(3);
  res.fill(appel*timedata); return res;
}
template<>
sotVectorUTheta DummyClass<sotVectorUTheta>::operator() (void)
{
  res.fill(12.6); return res;
}


// void dispArray( const sotSignalArray<int> &ar )
// {
//   for( unsigned int i=0;i<ar.rank;++i ) sotDEBUG(5)<<*ar.array[i]<<endl;
// }

void funtest( ml::Vector& v ){ } 

#include <vector>
int main( void )
{
   DummyClass<sotVectorUTheta> pro3;

   sotSignalTimeDependant<sotVectorUTheta,int> sig3(sotNOSIGNAL,"Sig3");
   sotSignalPtr<ml::Vector,int> sigTo3( NULL,"SigTo3" );

   ml::Vector v;
   sotVectorUTheta v3;
   funtest(v);
   funtest(v3);

   sig3.setFunction( boost::bind(&DummyClass<sotVectorUTheta>::fun,pro3,_1,_2) );
   try 
     {
       sigTo3.plug(&sig3);
     }
   catch( sotExceptionAbstract& e ) { cout << e << endl; exit(1); }
   
   sig3.access(1); sig3.setReady();
   sigTo3.access(2);
   cout << sigTo3.access(2);

  return 0;

}
