/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 * Copyright Projet JRL 2007
 *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 *
 * File:      test_flags.cc
 * Project:   sot
 * Author:    Nicolas Mansard
 *
 * Version control
 * ===============
 *
 *  $Id$
 *
 * Description
 * ============
 *
 *
 * ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/

/* -------------------------------------------------------------------------- */
/* --- INCLUDES ------------------------------------------------------------- */
/* -------------------------------------------------------------------------- */
#include <sot/sotFlags.h>
#include <iostream>
#include <sstream>

using namespace std;

int main( void )
{
  cout <<"Entering test" <<endl;
  sotFlags f1(128*112+84);
  sotFlags f2(198);
  cout<<"f1    "<<"\t"<<f1<<endl;
  cout<<"f2    "<<"\t"<<f2<<endl;

  cout<<endl;
  cout<<"1|2   "<<"\t"<<(f1|f2)<<endl;
  cout<<"1&2   "<<"\t"<<(f1&f2)<<endl;
  cout<<"TRUE  "<<"\t"<<(sotFlags(true))<<endl;
  cout<<"1&TRUE"<<"\t"<<(f1&sotFlags(true))<<endl;
  cout<<"1&!2 "<<"\t"<<(f1&!f2)<<endl;
  cout<<"1XOR2 "<<"\t"<<((f1&!f2)|(!f1&f2))<<endl;

  cout<<endl;
  cout<<"f1    "<<"\t"<<f1<<endl;
  cout<<"!2    "<<"\t"<<!f2<<endl;
  cout<<"1|!2 "<<"\t"<<(f1|!f2)<<endl;

  cout<<endl;
  if( f1&f2 ) cout<<"TRUE"; else cout<<"FALSE";  cout<<endl;
  if( f1&sotFlags() ) cout<<"TRUE"; else cout<<"FALSE";  cout<<endl;

  cout<<endl;
  cout<<"f1>>3 "<<"\t"<<sotFlags(f1>>3)<<endl;
  cout<<"f1>>5 "<<"\t"<<sotFlags(f1>>5)<<endl;
   
  cout<<"f1 byte per byte:";
  for(int i=0;i<16;++i) {if(! (i%8)) cout<<" ";  cout << f1(i); }  cout<<endl;

  cout<<endl;
  cout<<"L1   \t"<<FLAG_LINE_1<<endl;
  cout<<"L4   \t"<<FLAG_LINE_4<<endl;
  cout<<"L8   \t"<<FLAG_LINE_8<<endl;
  cout<<endl;

  istringstream iss("00101");
  sotFlags flread;
  iss >> flread;
  cout<<flread<<endl<<endl;
  
  cin >> flread;
   cout<<flread<<endl;
  
   char a; int i;
    cin >> i;
    cin >>a;
    cout << i << endl << a << endl;
// int input, sum=0;
// cin>>input;
// while (!cin.eof()) {
// sum += input;
// cin>>input;
// };
// cout<<"The Sum is "<<sum<<endl;

  return 0;
}
