/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 * Copyright Projet JRL 2007
 *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 *
 * File:      test_flags.cc
 * Project:   sot
 * Author:    Nicolas Mansard
 *
 * Version control
 * ===============
 *
 *  $Id$
 *
 * Description
 * ============
 *
 *
 * ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
//#undef WITH_OPENHRP

#include <iostream>
#include <sot/sotDebug.h>

#include <MatrixAbstractLayer/boost.h>

#include <boost/thread.hpp>
#include <unistd.h>

using namespace std;
namespace ml = maal::boost;

#include <sot/sotFactory.h>
#include <sot/sotEntity.h>
#include <sot/sotFeatureAbstract.h>

#include <sot/sotPluginLoader.h>
#include <sot/sotDebug.h>

#include <sot/sotInterpretor.h>

#include <sot/sotMailbox.h>
#include <sstream>

sotMailbox<ml::Vector> mailbox("mail");

void f( void ) 
{ 
  ml::Vector vect(25);
  for( int i=0;;++i )
    {
      for( int j=0;j<25;++j ) vect(j) = j+i*10;
      mailbox.post( vect );
      //usleep( 1000*50 );
    }
}


int main( int argc,char** argv )
{
  boost::thread th( f );

  try
    {
      
      //sotDEBUG(5) << " Loading..." << endl;
      sotPluginLoader pl;
      //pl.setDirectory( "lib/plugin" );
      //pl.loadPluginList( "plugin.txt" );
      //pl.loadPlugins();
      //sotDEBUG(5) << " Loading done." << endl;
      

      sotShell.referencePluginLoader( &pl );

      for( int i=1;i<argc;++i )
	{
	  std::istringstream script( argv[i] );
	  cout << "Run "<< argv[i] << endl;
	  sotShell.cmd( "run",script,cout );
	}

      sotShell.shell(cin,cout);
    }
  catch( sotExceptionAbstract& e )
    {
      cout << "!!  "  << e <<endl;
    }



  return 0;
}
 
