/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 * Copyright Projet JRL-Japan, 2008
 *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 *
 * File:      sot-0API.h
 * Project:   SOT
 * Author:    Francois Keith
 *
 * ===============
 *
 *  $Id$
 *
 * Description Definition of the API for the sot core, usefull for Win32
 * ============
 *
 *
 * ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/


#ifndef _SOT_API_H_
#define _SOT_API_H_

// Under Windows, for shared libraries (DLL) we need to define export on
// compilation or import on use (like a third party project).
// We exploit here the fact that cmake auto set xxx_EXPORTS (with S) on 
// compilation.
#if defined (WIN32) 
#  ifdef sot_0_EXPORTS 
#    define SOT_EXPORT __declspec(dllexport)
#  else  
#    define SOT_EXPORT __declspec(dllimport)
#  endif 
#else
#  define SOT_EXPORT
#endif

#endif /*_SOT_API_H_*/

